class AcidSynthModelWrapper(Module):
  __parameters__ = []
  __buffers__ = ["default_param_values", ]
  default_param_values : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  MAX_N_PARAMS : int
  SDK_VERSION : str
  CURRENT_TIME : float
  use_debug_mode : bool
  n_neutone_parameters : int
  neutone_parameters_metadata : Dict[str, Dict[str, str]]
  remapped_params : Dict[str, Tensor]
  neutone_parameter_names : List[str]
  neutone_parameter_descriptions : List[str]
  neutone_parameter_used : List[bool]
  neutone_parameter_types : List[str]
  in_n_ch : int
  curr_bs : int
  in_queue : __torch__.neutone_sdk.queues.CircularInplaceTensorQueue
  params_queue : __torch__.neutone_sdk.queues.CircularInplaceTensorQueue
  model_in_buffer : Tensor
  params_buffer : Tensor
  agg_params : Tensor
  model : __torch__.AcidSynthModel
  def forward(self: __torch__.AcidSynthModelWrapper,
    x: Tensor,
    params: Optional[Tensor]=None) -> Tensor:
    _0 = __torch__.neutone_sdk.utils.validate_waveform
    _1 = "Invalid model input audio length of {} samples, must be of length {} samples"
    _2 = "The model does not support a buffer size of {}"
    _3 = "AssertionError: Model uses a look-behind buffer, but the incoming buffer size has not been set. Be sure to call `set_sample_rate_and_buffer_size` before using the model."
    _4 = "Invalid model output audio length of {} samples, must be of length {} samples (are you using a look behind buffer incorrectly?)"
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      _5 = _0(x, (self).is_input_mono(), )
    else:
      pass
    in_n = torch.size(x, 1)
    if torch.__is__(params, None):
      params1 = torch.repeat((self).get_default_param_values(), [1, in_n])
      params0 = params1
    else:
      params0 = unchecked_cast(Tensor, params)
    use_debug_mode0 = self.use_debug_mode
    if use_debug_mode0:
      _6 = torch.size(params0)
      MAX_N_PARAMS = self.MAX_N_PARAMS
      _7 = torch.eq(_6, [MAX_N_PARAMS, in_n])
      if _7:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      curr_bs = self.curr_bs
      if torch.ne(curr_bs, -1):
        curr_bs0 = self.curr_bs
        if torch.eq(in_n, curr_bs0):
          pass
        else:
          curr_bs1 = self.curr_bs
          _8 = torch.format(_1, in_n, curr_bs1)
          _9 = torch.add("AssertionError: ", _8)
          ops.prim.RaiseException(_9)
      else:
        _10 = (self).get_native_buffer_sizes()
        if torch.gt(torch.len(_10), 0):
          _11 = (self).get_native_buffer_sizes()
          if torch.__contains__(_11, in_n):
            pass
          else:
            _12 = torch.add("AssertionError: ", torch.format(_2, in_n))
            ops.prim.RaiseException(_12)
        else:
          pass
      _13 = bool((self).get_look_behind_samples())
      if _13:
        curr_bs2 = self.curr_bs
        if torch.ne(curr_bs2, -1):
          pass
        else:
          ops.prim.RaiseException(_3)
      else:
        pass
    else:
      pass
    _14 = bool((self).get_look_behind_samples())
    if _14:
      in_queue = self.in_queue
      _15 = (in_queue).push(x, )
      params_queue = self.params_queue
      _16 = (params_queue).push(params0, )
      in_queue0 = self.in_queue
      size = in_queue0.size
      model_in_buffer = self.model_in_buffer
      _17 = torch.slice(torch.slice(model_in_buffer), 1, 0, torch.neg(size))
      _18 = torch.tensor(0, dtype=ops.prim.dtype(_17), device=ops.prim.device(_17))
      _19 = torch.copy_(_17, _18)
      in_queue1 = self.in_queue
      model_in_buffer0 = self.model_in_buffer
      _20 = torch.slice(torch.slice(model_in_buffer0), 1, torch.neg(size))
      _21 = (in_queue1).fill(_20, )
      _22 = (self).get_default_param_values()
      params_buffer = self.params_buffer
      _23 = torch.slice(torch.slice(params_buffer), 1, 0, torch.neg(size))
      _24 = torch.copy_(_23, _22)
      params_queue0 = self.params_queue
      params_buffer0 = self.params_buffer
      _25 = torch.slice(torch.slice(params_buffer0), 1, torch.neg(size))
      _26 = (params_queue0).fill(_25, )
      model_in_buffer1 = self.model_in_buffer
      params2, x0 = self.params_buffer, model_in_buffer1
    else:
      params2, x0 = params0, x
    params3 = (self).aggregate_params(params2, )
    use_debug_mode1 = self.use_debug_mode
    if use_debug_mode1:
      if torch.eq(torch.dim(params3), 2):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      _27 = torch.size(params3, 0)
      MAX_N_PARAMS0 = self.MAX_N_PARAMS
      if torch.eq(_27, MAX_N_PARAMS0):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    n_neutone_parameters = self.n_neutone_parameters
    for idx in range(n_neutone_parameters):
      _28 = torch.select(params3, 0, idx)
      remapped_params = self.remapped_params
      neutone_parameter_names = self.neutone_parameter_names
      torch._set_item(remapped_params, neutone_parameter_names[idx], _28)
    remapped_params0 = self.remapped_params
    x1 = (self).do_forward_pass(x0, remapped_params0, )
    use_debug_mode2 = self.use_debug_mode
    if use_debug_mode2:
      _29 = _0(x1, (self).is_output_mono(), )
      curr_bs3 = self.curr_bs
      if torch.eq(curr_bs3, -1):
        _30 = torch.eq(torch.size(x1, 1), in_n)
        if _30:
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
      else:
        _31 = torch.size(x1, 1)
        curr_bs4 = self.curr_bs
        if torch.eq(_31, curr_bs4):
          pass
        else:
          _32 = torch.size(x1, 1)
          curr_bs5 = self.curr_bs
          _33 = torch.format(_4, _32, curr_bs5)
          _34 = torch.add("AssertionError: ", _33)
          ops.prim.RaiseException(_34)
    else:
      pass
    return x1
  def calc_model_delay_samples(self: __torch__.AcidSynthModelWrapper) -> int:
    return 0
  def get_core_preserved_attributes(self: __torch__.AcidSynthModelWrapper) -> List[str]:
    _35 = ["model", "get_neutone_parameters_metadata", "get_default_param_values", "get_default_param_names", "get_default_param_descriptions", "get_default_param_types", "get_default_param_used", "get_wet_default_value", "get_dry_default_value", "get_input_gain_default_value", "get_output_gain_default_value", "get_core_preserved_attributes", "to_core_metadata"]
    return _35
  def get_default_param_descriptions(self: __torch__.AcidSynthModelWrapper) -> List[str]:
    return self.neutone_parameter_descriptions
  def get_default_param_names(self: __torch__.AcidSynthModelWrapper) -> List[str]:
    return self.neutone_parameter_names
  def get_default_param_types(self: __torch__.AcidSynthModelWrapper) -> List[str]:
    return self.neutone_parameter_types
  def get_default_param_used(self: __torch__.AcidSynthModelWrapper) -> List[bool]:
    return self.neutone_parameter_used
  def get_default_param_values(self: __torch__.AcidSynthModelWrapper) -> Tensor:
    return self.default_param_values
  def get_dry_default_value(self: __torch__.AcidSynthModelWrapper) -> float:
    return 0.
  def get_input_gain_default_value(self: __torch__.AcidSynthModelWrapper) -> float:
    return 0.5
  def get_native_buffer_sizes(self: __torch__.AcidSynthModelWrapper) -> List[int]:
    model = self.model
    ac = model.ac
    n_samples = ac.n_samples
    return [n_samples]
  def get_native_sample_rates(self: __torch__.AcidSynthModelWrapper) -> List[int]:
    model = self.model
    sr = model.sr
    return [sr]
  def get_neutone_parameters_metadata(self: __torch__.AcidSynthModelWrapper) -> Dict[str, Dict[str, str]]:
    return self.neutone_parameters_metadata
  def get_output_gain_default_value(self: __torch__.AcidSynthModelWrapper) -> float:
    return 0.5
  def get_preserved_attributes(self: __torch__.AcidSynthModelWrapper) -> List[str]:
    _36 = "set_daw_sample_rate_and_buffer_size"
    preserved_attrs = (self).get_core_preserved_attributes()
    _37 = ["is_input_mono", "is_output_mono", "get_native_sample_rates", "get_native_buffer_sizes", "is_resampling", "calc_model_delay_samples", "set_sample_rate_and_buffer_size", _36, "reset", "get_preserved_attributes", "to_metadata"]
    torch.extend(preserved_attrs, _37)
    return preserved_attrs
  def get_wet_default_value(self: __torch__.AcidSynthModelWrapper) -> float:
    return 1.
  def is_input_mono(self: __torch__.AcidSynthModelWrapper) -> bool:
    return True
  def is_output_mono(self: __torch__.AcidSynthModelWrapper) -> bool:
    return True
  def is_resampling(self: __torch__.AcidSynthModelWrapper) -> bool:
    return False
  def reset(self: __torch__.AcidSynthModelWrapper) -> bool:
    in_queue = self.in_queue
    _38 = (in_queue).reset()
    params_queue = self.params_queue
    _39 = (params_queue).reset()
    model_in_buffer = self.model_in_buffer
    _40 = torch.fill_(model_in_buffer, 0)
    _41 = (self).get_default_param_values()
    params_buffer = self.params_buffer
    _42 = torch.slice(torch.slice(params_buffer), 1)
    _43 = torch.copy_(_42, _41)
    return (self).reset_model()
  def set_daw_sample_rate_and_buffer_size(self: __torch__.AcidSynthModelWrapper,
    daw_sr: int,
    daw_buffer_size: int,
    model_sr: Optional[int]=None,
    model_buffer_size: Optional[int]=None) -> NoneType:
    _44 = (self).set_sample_rate_and_buffer_size(daw_sr, daw_buffer_size, )
    return None
  def set_sample_rate_and_buffer_size(self: __torch__.AcidSynthModelWrapper,
    sample_rate: int,
    n_samples: int) -> bool:
    _45 = "The model does not support a native buffer size of {}"
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      _46 = torch.len((self).get_native_buffer_sizes())
      if torch.gt(_46, 0):
        _47 = (self).get_native_buffer_sizes()
        _48 = torch.__contains__(_47, n_samples)
        if _48:
          pass
        else:
          _49 = torch.add("AssertionError: ", torch.format(_45, n_samples))
          ops.prim.RaiseException(_49)
      else:
        pass
    else:
      pass
    _50 = bool((self).get_look_behind_samples())
    if _50:
      curr_bs = self.curr_bs
      if torch.eq(curr_bs, -1):
        _51 = True
      else:
        curr_bs6 = self.curr_bs
        _51 = torch.ne(n_samples, curr_bs6)
      if _51:
        self.curr_bs = n_samples
        _52 = (self).get_look_behind_samples()
        curr_bs7 = self.curr_bs
        queue_len = torch.add(_52, curr_bs7)
        in_n_ch = self.in_n_ch
        use_debug_mode3 = self.use_debug_mode
        _53 = __torch__.neutone_sdk.queues.CircularInplaceTensorQueue.__new__(__torch__.neutone_sdk.queues.CircularInplaceTensorQueue)
        _54 = (_53).__init__(in_n_ch, queue_len, use_debug_mode3, )
        self.in_queue = _53
        MAX_N_PARAMS = self.MAX_N_PARAMS
        use_debug_mode4 = self.use_debug_mode
        _55 = __torch__.neutone_sdk.queues.CircularInplaceTensorQueue.__new__(__torch__.neutone_sdk.queues.CircularInplaceTensorQueue)
        _56 = (_55).__init__(MAX_N_PARAMS, queue_len, use_debug_mode4, )
        self.params_queue = _55
        in_n_ch0 = self.in_n_ch
        _57 = torch.zeros([in_n_ch0, queue_len])
        self.model_in_buffer = _57
        _58 = (self).get_default_param_values()
        _59 = torch.repeat(_58, [1, queue_len])
        self.params_buffer = _59
      else:
        pass
    else:
      pass
    _60 = (self).set_model_sample_rate_and_buffer_size(sample_rate, n_samples, )
    return _60
  def to_core_metadata(self: __torch__.AcidSynthModelWrapper) -> __torch__.neutone_sdk.core.CoreMetadata:
    _61 = (self).get_model_name()
    _62 = (self).get_model_authors()
    _63 = (self).get_model_short_description()
    _64 = (self).get_model_long_description()
    _65 = (self).get_neutone_parameters_metadata()
    _66 = (self).get_wet_default_value()
    _67 = (self).get_dry_default_value()
    _68 = (self).get_input_gain_default_value()
    _69 = (self).get_output_gain_default_value()
    _70 = (self).get_technical_description()
    _71 = (self).get_technical_links()
    _72 = (self).get_tags()
    _73 = (self).get_model_version()
    SDK_VERSION = self.SDK_VERSION
    CURRENT_TIME = self.CURRENT_TIME
    _74 = __torch__.neutone_sdk.core.CoreMetadata(_61, _62, _63, _64, _70, _71, _65, _66, _67, _68, _69, _72, _73, SDK_VERSION, CURRENT_TIME, "2.1.2", (self).get_citation(), (self).is_experimental())
    return _74
  def to_metadata(self: __torch__.AcidSynthModelWrapper) -> __torch__.neutone_sdk.wavform_to_wavform.WaveformToWaveformMetadata:
    core_metadata = (self).to_core_metadata()
    _75 = (core_metadata)[0]
    _76 = (core_metadata)[1]
    _77 = (core_metadata)[2]
    _78 = (core_metadata)[3]
    _79 = (core_metadata)[6]
    _80 = (core_metadata)[7]
    _81 = (core_metadata)[8]
    _82 = (core_metadata)[9]
    _83 = (core_metadata)[10]
    _84 = (core_metadata)[4]
    _85 = (core_metadata)[5]
    _86 = (core_metadata)[11]
    _87 = (core_metadata)[12]
    _88 = (core_metadata)[13]
    _89 = (core_metadata)[15]
    _90 = (core_metadata)[14]
    _91 = (core_metadata)[16]
    _92 = (core_metadata)[17]
    _93 = (self).is_input_mono()
    _94 = (self).is_output_mono()
    if (self).is_input_mono():
      _95 = "mono"
    else:
      _95 = "stereo"
    if (self).is_output_mono():
      _96 = "mono"
    else:
      _96 = "stereo"
    _97 = torch.format("{}-{}", _95, _96)
    _98 = (self).get_native_buffer_sizes()
    _99 = __torch__.neutone_sdk.wavform_to_wavform.WaveformToWaveformMetadata(_75, _76, _87, _77, _78, _84, _85, _86, _91, _92, _79, _80, _81, _82, _83, _93, _94, _97, (self).get_native_sample_rates(), _98, (self).get_look_behind_samples(), _88, _89, _90)
    return _99
  def get_look_behind_samples(self: __torch__.AcidSynthModelWrapper) -> int:
    return 0
  def aggregate_params(self: __torch__.AcidSynthModelWrapper,
    params: Tensor) -> Tensor:
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      if torch.eq(torch.dim(params), 2):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    agg_params = self.agg_params
    _100 = torch.mean(params, [1], True, out=agg_params)
    return self.agg_params
  def do_forward_pass(self: __torch__.AcidSynthModelWrapper,
    x: Tensor,
    params: Dict[str, Tensor]) -> Tensor:
    midi_f0_0to1 = params["midi_f0"]
    x2 = torch.unsqueeze(x, 1)
    model = self.model
    y = (model).forward(x2, midi_f0_0to1, )
    return torch.squeeze(y, 1)
  def reset_model(self: __torch__.AcidSynthModelWrapper) -> bool:
    return False
  def set_model_sample_rate_and_buffer_size(self: __torch__.AcidSynthModelWrapper,
    sample_rate: int,
    n_samples: int) -> bool:
    return False
  def get_model_name(self: __torch__.AcidSynthModelWrapper) -> str:
    model = self.model
    is_coeff_synth = model.is_coeff_synth
    if is_coeff_synth:
      prefix = "acid_synth_model_coeff"
    else:
      model0 = self.model
      is_rnn_synth = model0.is_rnn_synth
      if is_rnn_synth:
        prefix0 = "acid_synth_model_rnn"
      else:
        prefix0 = "acid_synth_model_lp"
      prefix = prefix0
    model1 = self.model
    is_td_synth = model1.is_td_synth
    if is_td_synth:
      suffix = "_td"
    else:
      suffix = torch.format("_fs")
    _101 = torch.format("{}{}", prefix, suffix)
    return _101
  def get_model_authors(self: __torch__.AcidSynthModelWrapper) -> List[str]:
    return ["Christopher Mitcheltree"]
  def get_model_short_description(self: __torch__.AcidSynthModelWrapper) -> str:
    _102 = "TB-303 DDSP and control model implementation."
    return _102
  def get_model_long_description(self: __torch__.AcidSynthModelWrapper) -> str:
    _103 = "TB-303 DDSP and control model implementation for \'Differentiable All-pole Filters for Time-varying Audio Systems\'."
    return _103
  def get_technical_description(self: __torch__.AcidSynthModelWrapper) -> str:
    _104 = "Wrapper for a TB-303 DDSP and control model implementation consisting of an analysis CNN that generates the parameters for a differentiable synth."
    return _104
  def get_technical_links(self: __torch__.AcidSynthModelWrapper) -> Dict[str, str]:
    _105 = {"Code": "https://github.com/DiffAPF/TB-303"}
    return _105
  def get_tags(self: __torch__.AcidSynthModelWrapper) -> List[str]:
    _106 = ["subtractive synth", "acid", "TB-303", "sound matching"]
    return _106
  def get_model_version(self: __torch__.AcidSynthModelWrapper) -> str:
    return "1.0.0"
  def get_citation(self: __torch__.AcidSynthModelWrapper) -> str:
    return ""
  def is_experimental(self: __torch__.AcidSynthModelWrapper) -> bool:
    return True
class AcidSynthModel(Module):
  __parameters__ = []
  __buffers__ = ["note_on_duration", "phase", "zi", "h_n", "c_n", ]
  note_on_duration : Tensor
  phase : Tensor
  zi : Tensor
  h_n : Tensor
  c_n : Tensor
  training : bool
  _is_full_backward_hook : Optional[bool]
  min_midi_f0 : int
  max_midi_f0 : int
  is_coeff_synth : bool
  is_rnn_synth : bool
  is_td_synth : bool
  ac : __torch__.audio_config.AudioConfig
  sr : int
  note_on_samples : int
  curr_env_val : float
  midi_f0_to_hz : Dict[int, Tensor]
  model : __torch__.models.Spectral2DCNN
  synth : __torch__.synths.AcidSynthLPBiquadFSM
  def forward(self: __torch__.AcidSynthModel,
    x: Tensor,
    midi_f0_0to1: Tensor) -> Tensor:
    _107 = __torch__.scripts.export_neutone_synth.make_envelope
    n_samples = torch.size(x, -1)
    max_midi_f0 = self.max_midi_f0
    min_midi_f0 = self.min_midi_f0
    _108 = torch.mul(midi_f0_0to1, torch.sub(max_midi_f0, min_midi_f0))
    min_midi_f00 = self.min_midi_f0
    midi_f0 = torch.add(_108, min_midi_f00)
    midi_f00 = torch.item(torch.to(torch.round(midi_f0), 3))
    midi_f0_to_hz = self.midi_f0_to_hz
    f0_hz = midi_f0_to_hz[int(midi_f00)]
    model = self.model
    model_out = (model).forward(x, )
    ac = self.ac
    alpha = (ac).convert_from_0to1("learned_alpha", model_out["learned_alpha_0to1"], )
    note_on_samples = self.note_on_samples
    curr_env_val = self.curr_env_val
    _109 = _107(x, note_on_samples, curr_env_val, )
    env, _110, new_env_val, = _109
    self.curr_env_val = new_env_val
    if bool(torch.ne(alpha, 1.)):
      _111 = torch.pow(env, alpha, out=env)
    else:
      pass
    is_coeff_synth = self.is_coeff_synth
    if is_coeff_synth:
      logits = model_out["logits"]
      filter_args = {"logits": logits}
    else:
      w_mod_sig = model_out["w_mod_sig"]
      q_mod_sig = torch.unsqueeze(model_out["q_0to1"], 1)
      filter_args0 = {"w_mod_sig": w_mod_sig, "q_mod_sig": q_mod_sig}
      filter_args = filter_args0
    is_td_synth = self.is_td_synth
    if is_td_synth:
      zi = self.zi
      torch._set_item(filter_args, "zi", zi)
    else:
      pass
    is_rnn_synth = self.is_rnn_synth
    if is_rnn_synth:
      h_n = self.h_n
      torch._set_item(filter_args, "h_n", h_n)
      c_n = self.c_n
      torch._set_item(filter_args, "c_n", c_n)
    else:
      pass
    ac0 = self.ac
    _112 = (ac0).convert_from_0to1("osc_shape", model_out["osc_shape_0to1"], )
    ac1 = self.ac
    _113 = (ac1).convert_from_0to1("osc_gain", model_out["osc_gain_0to1"], )
    ac2 = self.ac
    _114 = (ac2).convert_from_0to1("dist_gain", model_out["dist_gain_0to1"], )
    global_params = {"osc_shape": _112, "osc_gain": _113, "dist_gain": _114, "learned_alpha": alpha}
    synth = self.synth
    note_on_duration = self.note_on_duration
    phase = self.phase
    synth_out = (synth).forward(n_samples, f0_hz, note_on_duration, phase, filter_args, global_params, env, )
    wet = synth_out["wet"]
    sr = self.sr
    _115 = torch.reciprocal(torch.to(f0_hz, 7))
    _116 = torch.reciprocal(torch.mul(_115, sr))
    period_completion = torch.remainder(torch.mul(_116, n_samples), 1.)
    phase0 = self.phase
    _117 = torch.mul(period_completion, 6.2831853071795862)
    phase1 = self.phase
    _118 = torch.add(phase0, _117, out=phase1)
    is_td_synth0 = self.is_td_synth
    if is_td_synth0:
      y_a = synth_out["y_a"]
      _119 = torch.slice(torch.slice(y_a), 1, -2)
      zi0 = self.zi
      _120 = torch.copy_(torch.slice(torch.slice(zi0), 1), _119)
    else:
      pass
    is_rnn_synth0 = self.is_rnn_synth
    if is_rnn_synth0:
      self.h_n = synth_out["h_n"]
      self.c_n = synth_out["c_n"]
    else:
      pass
    return wet
