class SquareSawVCOLite(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  sr : int
  def forward(self: __torch__.acid_ddsp.synth_modules.SquareSawVCOLite,
    f0_hz: Tensor,
    osc_shape: Tensor,
    n_samples: Optional[int]=None,
    phase: Optional[Tensor]=None) -> Tensor:
    _0 = __torch__.acid_ddsp.synth_modules.calc_osc_arg
    _1 = __torch__.acid_ddsp.synth_modules.calc_n_partials
    _2 = uninitialized(int)
    if torch.le(1, torch.dim(f0_hz)):
      _3 = torch.le(torch.dim(f0_hz), 2)
    else:
      _3 = False
    if _3:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    if torch.le(1, torch.dim(osc_shape)):
      _4 = torch.le(torch.dim(osc_shape), 2)
    else:
      _4 = False
    if _4:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    if torch.eq(torch.dim(f0_hz), 1):
      if torch.__isnot__(n_samples, None):
        n_samples1 = unchecked_cast(int, n_samples)
      else:
        ops.prim.RaiseException("AssertionError: ")
        n_samples1 = _2
      f0_hz1 = torch.unsqueeze(f0_hz, 1)
      f0_hz2 = torch.expand(f0_hz1, [-1, n_samples1])
      n_samples0, f0_hz0 = n_samples1, f0_hz2
    else:
      n_samples0, f0_hz0 = n_samples, f0_hz
    if torch.eq(torch.dim(osc_shape), 1):
      if torch.__isnot__(n_samples0, None):
        n_samples3 = unchecked_cast(int, n_samples0)
      else:
        ops.prim.RaiseException("AssertionError: ")
        n_samples3 = _2
      osc_shape1 = torch.unsqueeze(osc_shape, 1)
      osc_shape2 = torch.expand(osc_shape1, [-1, n_samples3])
      n_samples2, osc_shape0 = n_samples3, osc_shape2
    else:
      n_samples2, osc_shape0 = n_samples0, osc_shape
    sr = self.sr
    arg = _0(sr, f0_hz0, n_samples2, phase, )
    n_partials = _1(f0_hz0, )
    _5 = torch.mul(n_partials, 3.1415926535897931)
    _6 = torch.div(torch.mul(_5, torch.sin(arg)), 2)
    square_wave = torch.tanh(_6)
    _7 = torch.add(torch.neg(torch.div(osc_shape0, 2)), 1)
    _8 = torch.mul(_7, square_wave)
    _9 = torch.mul(osc_shape0, torch.cos(arg))
    return torch.mul(_8, torch.add(_9, 1))
class ExpDecayEnv(Module):
  __parameters__ = []
  __buffers__ = ["zero", "one", ]
  zero : Tensor
  one : Tensor
  training : bool
  _is_full_backward_hook : Optional[bool]
  sr : int
  eps : float
  def forward(self: __torch__.acid_ddsp.synth_modules.ExpDecayEnv,
    alpha: Tensor,
    note_on_duration: Tensor,
    n_samples: int) -> Tensor:
    if torch.eq(torch.dim(alpha), 1):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _10 = torch.eq(torch.size(alpha), torch.size(note_on_duration))
    if _10:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _11 = bool(torch.ge(torch.min(alpha), 0.))
    if _11:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    envelope = (self).ramp(note_on_duration, alpha, n_samples, None, True, )
    return envelope
  def ramp(self: __torch__.acid_ddsp.synth_modules.ExpDecayEnv,
    duration_sec: Tensor,
    alpha: Tensor,
    n_samples: int,
    start_sec: Optional[Tensor]=None,
    inverse: bool=False) -> Tensor:
    _12 = torch.eq(torch.dim(duration_sec), 1)
    if _12:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _13 = torch.eq(torch.size(alpha), torch.size(duration_sec))
    if _13:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    bs = torch.size(duration_sec, 0)
    _14 = (self).seconds_to_samples(duration_sec, )
    duration = torch.unsqueeze(_14, 1)
    _15 = bool(torch.ge(torch.min(duration), 1.))
    if _15:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _16 = torch.le(torch.max(duration), n_samples)
    if bool(_16):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    zero = self.zero
    if torch.__isnot__(start_sec, None):
      start_sec0 = unchecked_cast(Tensor, start_sec)
      _17 = torch.eq(torch.size(start_sec0), torch.size(duration_sec))
      if _17:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      _18 = (self).seconds_to_samples(start_sec0, )
      start = torch.unsqueeze(_18, 1)
    else:
      start = zero
    _19 = bool(torch.ge(torch.min(start), 0.))
    if _19:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _20 = torch.lt(torch.max(start), n_samples)
    if bool(_20):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    range_ = torch.arange(n_samples, dtype=ops.prim.dtype(duration), layout=None, device=ops.prim.device(duration))
    ramp = torch.expand(range_, [bs, torch.size(range_, 0)])
    ramp0 = torch.sub(ramp, start)
    zero0 = self.zero
    ramp1 = torch.maximum(ramp0, zero0)
    eps = self.eps
    _21 = torch.div(torch.add(ramp1, eps), duration)
    eps0 = self.eps
    ramp2 = torch.add(_21, eps0)
    one = self.one
    ramp3 = torch.minimum(ramp2, one)
    if inverse:
      ramp5 = torch.where(torch.gt(duration, 0.), torch.add(torch.neg(ramp3), 1.), ramp3)
      ramp4 = ramp5
    else:
      ramp4 = ramp3
    ramp6 = torch.pow(ramp4, torch.unsqueeze(alpha, 1))
    return ramp6
  def seconds_to_samples(self: __torch__.acid_ddsp.synth_modules.ExpDecayEnv,
    seconds: Tensor) -> Tensor:
    sr = self.sr
    return torch.mul(seconds, sr)
def calc_osc_arg(sr: int,
    f0_hz: Tensor,
    n_samples: Optional[int]=None,
    phase: Optional[Tensor]=None) -> Tensor:
  _22 = uninitialized(Tensor)
  _23 = uninitialized(int)
  if torch.le(1, torch.dim(f0_hz)):
    _24 = torch.le(torch.dim(f0_hz), 2)
  else:
    _24 = False
  if _24:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  bs = torch.size(f0_hz, 0)
  if torch.eq(torch.dim(f0_hz), 1):
    if torch.__isnot__(n_samples, None):
      n_samples4 = unchecked_cast(int, n_samples)
    else:
      ops.prim.RaiseException("AssertionError: ")
      n_samples4 = _23
    f0_hz4 = torch.unsqueeze(f0_hz, 1)
    f0_hz5 = torch.expand(f0_hz4, [-1, n_samples4])
    f0_hz3 = f0_hz5
  else:
    f0_hz3 = f0_hz
  if torch.__is__(phase, None):
    ops.prim.RaiseException("AssertionError: ")
    phase0 = _22
  else:
    phase0 = unchecked_cast(Tensor, phase)
  if torch.eq(torch.size(phase0), [bs, 1]):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _25 = torch.div(torch.mul(f0_hz3, 6.2831853071795862), sr)
  arg = torch.cumsum(_25, 1)
  return torch.add_(arg, phase0)
def calc_n_partials(f0_hz: Tensor) -> Tensor:
  if torch.eq(torch.dim(f0_hz), 2):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _26, _27 = torch.max(f0_hz, 1, True)
  _28 = torch.reciprocal(torch.mul(_26, torch.log10(_26)))
  return torch.mul(_28, 12000)
