class AudioConfig:
  sr : int
  buffer_size_seconds : float
  note_on_duration : float
  min_f0_hz : float
  max_f0_hz : float
  min_attack : float
  max_attack : float
  min_decay : float
  max_decay : float
  min_sustain : float
  max_sustain : float
  min_release : float
  max_release : float
  min_alpha : float
  max_alpha : float
  min_w_hz : float
  max_w_hz : float
  min_q : float
  max_q : float
  min_dist_gain : float
  max_dist_gain : float
  min_osc_shape : float
  max_osc_shape : float
  min_osc_gain : float
  max_osc_gain : float
  min_learned_alpha : float
  max_learned_alpha : float
  stability_eps : float
  n_samples : int
  min_w : float
  max_w : float
  min_vals : Dict[str, float]
  max_vals : Dict[str, float]
  def __init__(self: __torch__.audio_config.AudioConfig,
    sr: int=48000,
    buffer_size_seconds: float=0.125,
    note_on_duration: float=0.10000000000000001,
    min_f0_hz: float=32.700000000000003,
    max_f0_hz: float=523.25,
    min_attack: float=0.001,
    max_attack: float=0.001,
    min_decay: float=0.099000000000000005,
    max_decay: float=0.099000000000000005,
    min_sustain: float=0.5,
    max_sustain: float=0.5,
    min_release: float=0.025000000000000001,
    max_release: float=0.025000000000000001,
    min_alpha: float=1.,
    max_alpha: float=1.,
    min_w_hz: float=100.,
    max_w_hz: float=8000.,
    min_q: float=0.70709999999999995,
    max_q: float=8.,
    min_dist_gain: float=1.,
    max_dist_gain: float=1.,
    min_osc_shape: float=1.,
    max_osc_shape: float=1.,
    min_osc_gain: float=1.,
    max_osc_gain: float=1.,
    min_learned_alpha: float=1.,
    max_learned_alpha: float=1.,
    stability_eps: float=0.001) -> NoneType:
    self.sr = sr
    self.buffer_size_seconds = buffer_size_seconds
    self.note_on_duration = note_on_duration
    self.min_f0_hz = min_f0_hz
    self.max_f0_hz = max_f0_hz
    self.min_attack = min_attack
    self.max_attack = max_attack
    self.min_decay = min_decay
    self.max_decay = max_decay
    self.min_sustain = min_sustain
    self.max_sustain = max_sustain
    self.min_release = min_release
    self.max_release = max_release
    self.min_alpha = min_alpha
    self.max_alpha = max_alpha
    self.min_w_hz = min_w_hz
    self.max_w_hz = max_w_hz
    self.min_q = min_q
    self.max_q = max_q
    self.min_dist_gain = min_dist_gain
    self.max_dist_gain = max_dist_gain
    self.min_osc_shape = min_osc_shape
    self.max_osc_shape = max_osc_shape
    self.min_osc_gain = min_osc_gain
    self.max_osc_gain = max_osc_gain
    self.min_learned_alpha = min_learned_alpha
    self.max_learned_alpha = max_learned_alpha
    self.stability_eps = stability_eps
    _0 = int(torch.mul(sr, buffer_size_seconds))
    self.n_samples = _0
    self.min_w = (self).calc_w(min_w_hz, )
    self.max_w = (self).calc_w(max_w_hz, )
    min_w = self.min_w
    _1 = {"f0_hz": min_f0_hz, "attack": min_attack, "decay": min_decay, "sustain": min_sustain, "release": min_release, "alpha": min_alpha, "w_hz": min_w_hz, "w": min_w, "q": min_q, "dist_gain": min_dist_gain, "osc_shape": min_osc_shape, "osc_gain": min_osc_gain, "learned_alpha": min_learned_alpha}
    self.min_vals = _1
    max_w = self.max_w
    _2 = {"f0_hz": max_f0_hz, "attack": max_attack, "decay": max_decay, "sustain": max_sustain, "release": max_release, "alpha": max_alpha, "w_hz": max_w_hz, "w": max_w, "q": max_q, "dist_gain": max_dist_gain, "osc_shape": max_osc_shape, "osc_gain": max_osc_gain, "learned_alpha": max_learned_alpha}
    self.max_vals = _2
    min_vals = self.min_vals
    _3 = torch.keys(min_vals)
    for _4 in range(torch.len(_3)):
      param_name = _3[_4]
      min_vals0 = self.min_vals
      _5 = min_vals0[param_name]
      max_vals = self.max_vals
      _6 = torch.le(_5, max_vals[param_name])
      if _6:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    return None
  def calc_w(self: __torch__.audio_config.AudioConfig,
    w_hz: float) -> float:
    _7 = torch.mul(6.2831853071795862, w_hz)
    sr = self.sr
    return torch.div(_7, sr)
  def convert_from_0to1(self: __torch__.audio_config.AudioConfig,
    param_name: str,
    val: Tensor) -> Tensor:
    if bool(torch.ge(torch.min(val), 0.)):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    if bool(torch.le(torch.max(val), 1.)):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    max_vals = self.max_vals
    _8 = max_vals[param_name]
    min_vals = self.min_vals
    _9 = torch.mul(val, torch.sub(_8, min_vals[param_name]))
    min_vals1 = self.min_vals
    _10 = torch.add(_9, min_vals1[param_name])
    return _10
  def convert_to_0to1(self: __torch__.audio_config.AudioConfig,
    param_name: str,
    val: Tensor) -> Tensor:
    _11 = torch.min(val)
    min_vals = self.min_vals
    _12 = bool(torch.ge(_11, min_vals[param_name]))
    if _12:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _13 = torch.max(val)
    max_vals = self.max_vals
    _14 = bool(torch.le(_13, max_vals[param_name]))
    if _14:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    if (self).is_fixed(param_name, ):
      _15 = torch.zeros_like(val)
    else:
      min_vals2 = self.min_vals
      _16 = torch.sub(val, min_vals2[param_name])
      max_vals0 = self.max_vals
      _17 = max_vals0[param_name]
      min_vals3 = self.min_vals
      _18 = torch.sub(_17, min_vals3[param_name])
      _15 = torch.div(_16, _18)
    return _15
  def is_fixed(self: __torch__.audio_config.AudioConfig,
    param_name: str) -> bool:
    min_vals = self.min_vals
    _19 = min_vals[param_name]
    max_vals = self.max_vals
    return torch.eq(_19, max_vals[param_name])
