class LogMelSpecFeatureExtractor(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  sr : float
  n_fft : int
  hop_len : int
  n_mels : int
  normalized : bool
  center : bool
  freq_mask_amount : float
  eps : float
  center_freqs : List[float]
  n_bins : int
  mel_spec : __torch__.torchaudio.transforms._transforms.MelSpectrogram
  freq_masking : __torch__.torchaudio.transforms._transforms.FrequencyMasking
  def forward(self: __torch__.feature_extraction.LogMelSpecFeatureExtractor,
    x: Tensor) -> Tensor:
    if torch.eq(torch.dim(x), 3):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    mel_spec = self.mel_spec
    x0 = (mel_spec).forward(x, )
    training = self.training
    if training:
      freq_mask_amount = self.freq_mask_amount
      if torch.gt(freq_mask_amount, 0):
        freq_masking = self.freq_masking
        x3 = (freq_masking).forward(x0, 0., )
        x2 = x3
      else:
        x2 = x0
      x1 = x2
    else:
      x1 = x0
    eps = self.eps
    x4 = torch.clamp(x1, eps)
    return torch.log(x4)
