class TimeVaryingLPBiquadFSM(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  min_w : Tensor
  max_w : Tensor
  min_q : Tensor
  max_q : Tensor
  log_min_w : Tensor
  log_max_w : Tensor
  log_min_q : Tensor
  log_max_q : Tensor
  eps : float
  modulate_log_w : bool
  modulate_log_q : bool
  is_scriptable : bool
  filter : __torch__.filters.TimeVaryingIIRFSM
  def forward(self: __torch__.filters.TimeVaryingLPBiquadFSM,
    x: Tensor,
    w_mod_sig: Optional[Tensor]=None,
    q_mod_sig: Optional[Tensor]=None,
    interp_coeff: bool=False,
    zi: Optional[Tensor]=None) -> Tuple[Tensor, Tensor, Tensor, Optional[Tensor]]:
    _0 = __torch__.util.linear_interpolate_dim
    _1 = __torch__.filters.calc_lp_biquad_coeff
    _2 = (self).calc_w_and_q(x, w_mod_sig, q_mod_sig, )
    w, q, = _2
    n_samples = torch.size(x, 1)
    filter = self.filter
    n_frames = (filter).calc_n_frames(n_samples, )
    if torch.__not__(interp_coeff):
      w0, q0 = _0(w, n_frames, 1, True, ), _0(q, n_frames, 1, True, )
    else:
      w0, q0 = w, q
    eps = self.eps
    a_coeff, b_coeff, = _1(w0, q0, eps, )
    if interp_coeff:
      a_coeff0, b_coeff0 = _0(a_coeff, n_frames, 1, True, ), _0(b_coeff, n_frames, 1, True, )
    else:
      a_coeff0, b_coeff0 = a_coeff, b_coeff
    _3 = torch.slice(torch.slice(a_coeff0), 1)
    a1 = torch.select(_3, 2, 0)
    _4 = torch.slice(torch.slice(a_coeff0), 1)
    a2 = torch.select(_4, 2, 1)
    a0 = torch.ones_like(a1)
    a_coeff1 = torch.stack([a0, a1, a2], 2)
    filter0 = self.filter
    y = (filter0).forward(x, a_coeff1, b_coeff0, )
    return (y, a_coeff1, b_coeff0, None)
  def calc_w_and_q(self: __torch__.filters.TimeVaryingLPBiquadFSM,
    x: Tensor,
    w_mod_sig: Optional[Tensor]=None,
    q_mod_sig: Optional[Tensor]=None) -> Tuple[Tensor, Tensor]:
    if torch.__is__(w_mod_sig, None):
      w_mod_sig0 = torch.zeros_like(x)
    else:
      w_mod_sig0 = unchecked_cast(Tensor, w_mod_sig)
    if torch.__is__(q_mod_sig, None):
      q_mod_sig0 = torch.zeros_like(x)
    else:
      q_mod_sig0 = unchecked_cast(Tensor, q_mod_sig)
    if torch.eq(torch.dim(x), 2):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    if torch.eq(torch.dim(w_mod_sig0), 2):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _5 = bool(torch.ge(torch.min(w_mod_sig0), 0.))
    if _5:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _6 = bool(torch.le(torch.max(w_mod_sig0), 1.))
    if _6:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    if torch.eq(torch.dim(q_mod_sig0), 2):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _7 = bool(torch.ge(torch.min(q_mod_sig0), 0.))
    if _7:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _8 = bool(torch.le(torch.max(q_mod_sig0), 1.))
    if _8:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    modulate_log_w = self.modulate_log_w
    if modulate_log_w:
      log_min_w = self.log_min_w
      log_max_w = self.log_max_w
      log_min_w0 = self.log_min_w
      _9 = torch.mul(torch.sub(log_max_w, log_min_w0), w_mod_sig0)
      log_w = torch.add(log_min_w, _9)
      w = torch.exp(log_w)
    else:
      min_w = self.min_w
      max_w = self.max_w
      min_w0 = self.min_w
      _10 = torch.mul(torch.sub(max_w, min_w0), w_mod_sig0)
      w = torch.add(min_w, _10)
    modulate_log_q = self.modulate_log_q
    if modulate_log_q:
      log_min_q = self.log_min_q
      log_max_q = self.log_max_q
      log_min_q0 = self.log_min_q
      _11 = torch.mul(torch.sub(log_max_q, log_min_q0), q_mod_sig0)
      log_q = torch.add(log_min_q, _11)
      q = torch.exp(log_q)
    else:
      min_q = self.min_q
      max_q = self.max_q
      min_q0 = self.min_q
      _12 = torch.mul(torch.sub(max_q, min_q0), q_mod_sig0)
      q = torch.add(min_q, _12)
    return (w, q)
class TimeVaryingIIRFSM(Module):
  __parameters__ = []
  __buffers__ = ["hann", ]
  hann : Tensor
  training : bool
  _is_full_backward_hook : Optional[bool]
  sr : int
  overlap : float
  oversampling_factor : int
  win_len : int
  hop_len : int
  n_fft : int
  def forward(self: __torch__.filters.TimeVaryingIIRFSM,
    x: Tensor,
    a: Tensor,
    b: Tensor) -> Tensor:
    if torch.eq(torch.dim(x), 2):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    if torch.eq(torch.dim(a), 3):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    if torch.eq(torch.dim(b), 3):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    x_n_samples = torch.size(x, 1)
    n_fft = self.n_fft
    hop_len = self.hop_len
    win_len = self.win_len
    hann = self.hann
    X = __torch__.torch.functional.stft(x, n_fft, hop_len, win_len, hann, True, "constant", False, True, True, )
    n_frames = torch.size(X, 2)
    _13 = torch.eq(torch.size(a, 1), n_frames)
    if _13:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    _14 = torch.eq(torch.size(b, 1), n_frames)
    if _14:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    n_fft0 = self.n_fft
    A = torch.fft_rfft(a, n_fft0)
    n_fft1 = self.n_fft
    B = torch.fft_rfft(b, n_fft1)
    H = torch.div(B, A)
    H0 = torch.transpose(H, 1, 2)
    Y = torch.mul(X, H0)
    n_fft2 = self.n_fft
    hop_len0 = self.hop_len
    win_len0 = self.win_len
    hann0 = self.hann
    y = torch.istft(Y, n_fft2, hop_len0, win_len0, hann0, True, False, True, x_n_samples)
    return y
  def calc_n_frames(self: __torch__.filters.TimeVaryingIIRFSM,
    n_samples: int) -> int:
    hop_len = self.hop_len
    n_frames = torch.add(torch.floordiv(n_samples, hop_len), 1)
    return n_frames
def calc_lp_biquad_coeff(w: Tensor,
    q: Tensor,
    eps: float=0.001) -> Tuple[Tensor, Tensor]:
  if torch.eq(torch.dim(w), 2):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  if torch.eq(torch.dim(q), 2):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  if bool(torch.ge(torch.min(w), 0.)):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _15 = torch.le(torch.max(w), 3.1415926535897931)
  if bool(_15):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  if bool(torch.gt(torch.min(q), 0.)):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  stability_factor = torch.sub(1., eps)
  alpha_q = torch.div(torch.sin(w), torch.mul(q, 2))
  a0 = torch.add(alpha_q, 1.)
  a1 = torch.mul(torch.mul(torch.cos(w), -2.), stability_factor)
  a10 = torch.div(a1, a0)
  a2 = torch.mul(torch.add(torch.neg(alpha_q), 1.), stability_factor)
  a20 = torch.div(a2, a0)
  _16 = torch.all(torch.lt(torch.abs(a10), 2.))
  if bool(_16):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  if bool(torch.all(torch.lt(a20, 1.))):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _17 = torch.all(torch.lt(a10, torch.add(a20, 1.)))
  if bool(_17):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _18 = torch.gt(a10, torch.neg(torch.add(a20, 1.)))
  if bool(torch.all(_18)):
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  a = torch.stack([a10, a20], 2)
  _19 = torch.add(torch.neg(torch.cos(w)), 1.)
  b0 = torch.div(_19, 2.)
  b00 = torch.div(b0, a0)
  b1 = torch.add(torch.neg(torch.cos(w)), 1.)
  b10 = torch.div(b1, a0)
  _20 = torch.add(torch.neg(torch.cos(w)), 1.)
  b2 = torch.div(_20, 2.)
  b20 = torch.div(b2, a0)
  b = torch.stack([b00, b10, b20], 2)
  return (a, b)
