class Spectral2DCNN(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : NoneType
  in_ch : int
  kernel_size : Tuple[int, int]
  pool_size : Tuple[int, int]
  use_ln : bool
  n_temporal_params : int
  temporal_params_name : str
  temp_params_act_name : str
  dropout : float
  out_channels : List[int]
  bin_dilations : List[int]
  temp_dilations : List[int]
  global_param_names : List[str]
  fe : __torch__.feature_extraction.LogMelSpecFeatureExtractor
  cnn : __torch__.torch.nn.modules.container.Sequential
  out_temp : __torch__.torch.nn.modules.linear.Linear
  out_global : __torch__.torch.nn.modules.container.ModuleDict
  def forward(self: __torch__.models.Spectral2DCNN,
    x: Tensor) -> Dict[str, Tensor]:
    _0 = uninitialized(Tensor)
    if torch.eq(torch.dim(x), 3):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    out_dict = annotate(Dict[str, Tensor], {})
    fe = self.fe
    log_spec = (fe).forward(x, )
    torch._set_item(out_dict, "log_spec_wet", log_spec)
    cnn = self.cnn
    x0 = (cnn).forward(log_spec, )
    x1 = torch.mean(x0, [-2])
    latent = torch.transpose(x1, 1, 2)
    torch._set_item(out_dict, "latent", latent)
    out_temp = self.out_temp
    x2 = (out_temp).forward(latent, )
    temp_params_act_name = self.temp_params_act_name
    _1 = torch.eq(temp_params_act_name, "sigmoid")
    if _1:
      out_temp0 = torch.sigmoid(x2)
    else:
      temp_params_act_name0 = self.temp_params_act_name
      _2 = torch.eq(temp_params_act_name0, "tanh")
      if _2:
        out_temp1 = torch.tanh(x2)
      else:
        temp_params_act_name1 = self.temp_params_act_name
        _3 = torch.eq(temp_params_act_name1, "clamp")
        if _3:
          out_temp2 = torch.clamp(x2, 0., 1.)
        else:
          temp_params_act_name2 = self.temp_params_act_name
          _4 = torch.format("Unknown activation: {}", temp_params_act_name2)
          ops.prim.RaiseException(_4, "builtins.ValueError")
          out_temp2 = _0
        out_temp1 = out_temp2
      out_temp0 = out_temp1
    temporal_params_name = self.temporal_params_name
    torch._set_item(out_dict, temporal_params_name, out_temp0)
    x3 = torch.mean(latent, [-2])
    out_global = self.out_global
    q_0to1 = out_global.q_0to1
    osc_shape_0to1 = out_global.osc_shape_0to1
    osc_gain_0to1 = out_global.osc_gain_0to1
    dist_gain_0to1 = out_global.dist_gain_0to1
    learned_alpha_0to1 = out_global.learned_alpha_0to1
    p_val_hat = torch.squeeze((q_0to1).forward(x3, ), -1)
    torch._set_item(out_dict, "q_0to1", p_val_hat)
    p_val_hat0 = torch.squeeze((osc_shape_0to1).forward(x3, ), -1)
    torch._set_item(out_dict, "osc_shape_0to1", p_val_hat0)
    p_val_hat1 = torch.squeeze((osc_gain_0to1).forward(x3, ), -1)
    torch._set_item(out_dict, "osc_gain_0to1", p_val_hat1)
    p_val_hat2 = torch.squeeze((dist_gain_0to1).forward(x3, ), -1)
    torch._set_item(out_dict, "dist_gain_0to1", p_val_hat2)
    p_val_hat3 = torch.squeeze((learned_alpha_0to1).forward(x3, ), -1)
    torch._set_item(out_dict, "learned_alpha_0to1", p_val_hat3)
    return out_dict
class Spectral2DCNNBlock(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  use_ln : bool
  conv : __torch__.torch.nn.modules.conv.Conv2d
  pool : __torch__.torch.nn.modules.pooling.MaxPool2d
  act : __torch__.torch.nn.modules.activation.PReLU
  def forward(self: __torch__.models.Spectral2DCNNBlock,
    x: Tensor) -> Tensor:
    _5 = __torch__.torch.nn.functional.layer_norm
    if torch.eq(torch.dim(x), 4):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    n_bin = torch.size(x, 2)
    n_frame = torch.size(x, 3)
    use_ln = self.use_ln
    if use_ln:
      x5 = _5(x, [n_bin, n_frame], None, None, 1.0000000000000001e-05, )
      x4 = x5
    else:
      x4 = x
    conv = self.conv
    x6 = (conv).forward(x4, )
    pool = self.pool
    x7 = (pool).forward(x6, )
    act = self.act
    return (act).forward(x7, )
