class ChannelNormalizerSandwich(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  use_debug_mode : bool
  half_scalar : Tensor
  def forward(self: __torch__.neutone_sdk.sandwich.ChannelNormalizerSandwich,
    x: Tensor,
    should_be_mono: bool,
    out_buffer: Tensor) -> Tensor:
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      if torch.eq(torch.dim(x), 2):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      if torch.le(torch.size(x, 0), 2):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      _0 = torch.eq(torch.dim(out_buffer), 2)
      if _0:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      _1 = torch.eq(torch.size(out_buffer, 0), 2)
      if _1:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      _2 = torch.ge(torch.size(out_buffer, 1), torch.size(x, 1))
      if _2:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    n_ch = torch.size(x, 0)
    n_samples = torch.size(x, 1)
    if should_be_mono:
      _3 = torch.eq(n_ch, 2)
    else:
      _3 = False
    if _3:
      out = torch.slice(torch.slice(out_buffer, 0, 0, 1), 1, 0, n_samples)
      _4 = torch.slice(torch.slice(x, 0, 0, 1), 1)
      _5 = torch.slice(torch.slice(x, 0, 1, 2), 1)
      _6 = torch.add(_4, _5, out=out)
      half_scalar = self.half_scalar
      _7 = torch.mul(out, half_scalar, out=out)
      x0 = out
    else:
      if torch.__not__(should_be_mono):
        _8 = torch.eq(n_ch, 1)
      else:
        _8 = False
      if _8:
        _9 = torch.slice(out_buffer, 0, 0, 1)
        _10 = torch.slice(_9, 1, 0, n_samples)
        _11 = torch.copy_(_10, x)
        _12 = torch.slice(out_buffer, 0, 1, 2)
        _13 = torch.slice(_12, 1, 0, n_samples)
        _14 = torch.copy_(_13, x)
        x1 = out_buffer
      else:
        x1 = x
      x0 = x1
    return x0
class Inplace4pHermiteResampler(Module):
  __parameters__ = []
  __buffers__ = []
  y_m1_idx_in : Tensor
  y2_idx_in : Tensor
  y_m1_in : Tensor
  y2_in : Tensor
  c1_in : Tensor
  c2_in : Tensor
  c3_in : Tensor
  y_m1_idx_out : Tensor
  y2_idx_out : Tensor
  y_m1_out : Tensor
  y2_out : Tensor
  c1_out : Tensor
  c2_out : Tensor
  c3_out : Tensor
  const_0p5 : Tensor
  const_1p5 : Tensor
  const_2p0 : Tensor
  const_2p5 : Tensor
  const_3p0 : Tensor
  in_n_ch : int
  out_n_ch : int
  x_in : Tensor
  y0_idx_in : Tensor
  y1_idx_in : Tensor
  y0_in : Tensor
  y1_in : Tensor
  x_out : Tensor
  y0_idx_out : Tensor
  y1_idx_out : Tensor
  y0_out : Tensor
  y1_out : Tensor
  training : bool
  _is_full_backward_hook : Optional[bool]
  use_debug_mode : bool
  in_sr : int
  out_sr : int
  in_bs : int
  out_bs : int
  def process_in(self: __torch__.neutone_sdk.sandwich.Inplace4pHermiteResampler,
    y: Tensor) -> Tensor:
    in_n_ch = self.in_n_ch
    in_bs = self.in_bs
    x_in = self.x_in
    y_m1_idx_in = self.y_m1_idx_in
    y0_idx_in = self.y0_idx_in
    y1_idx_in = self.y1_idx_in
    y2_idx_in = self.y2_idx_in
    y_m1_in = self.y_m1_in
    y0_in = self.y0_in
    y1_in = self.y1_in
    y2_in = self.y2_in
    c1_in = self.c1_in
    c2_in = self.c2_in
    c3_in = self.c3_in
    _15 = (self)._process_4p_hermite_opt(y, in_n_ch, in_bs, x_in, y_m1_idx_in, y0_idx_in, y1_idx_in, y2_idx_in, y_m1_in, y0_in, y1_in, y2_in, c1_in, c2_in, c3_in, )
    return _15
  def _process_4p_hermite_opt(self: __torch__.neutone_sdk.sandwich.Inplace4pHermiteResampler,
    y: Tensor,
    n_ch: int,
    in_bs: int,
    x: Tensor,
    y_m1_idx: Tensor,
    y0_idx: Tensor,
    y1_idx: Tensor,
    y2_idx: Tensor,
    y_m1: Tensor,
    y0: Tensor,
    y1: Tensor,
    y2: Tensor,
    c1: Tensor,
    c2: Tensor,
    c3: Tensor) -> Tensor:
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      _16 = torch.eq(torch.size(y), [n_ch, in_bs])
      if _16:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    _17 = torch.__not__((self).is_resampling())
    if _17:
      _18 = y
    else:
      _19 = torch.index_select(y, 1, y_m1_idx, out=y_m1)
      _20 = torch.index_select(y, 1, y0_idx, out=y0)
      _21 = torch.index_select(y, 1, y1_idx, out=y1)
      _22 = torch.index_select(y, 1, y2_idx, out=y2)
      _23 = torch.sub(y0, y1, out=c2)
      _24 = torch.sub(y1, y_m1, out=c1)
      const_3p0 = self.const_3p0
      _25 = torch.mul(const_3p0, c2, out=c3)
      _26 = torch.add(c3, y2, out=c3)
      _27 = torch.sub(c3, y_m1, out=c3)
      const_2p0 = self.const_2p0
      _28 = torch.mul(const_2p0, c2, out=c2)
      _29 = torch.add(c2, c1, out=c2)
      _30 = torch.add(c2, c3, out=c2)
      _31 = torch.neg(c2, out=c2)
      _32 = torch.mul(c3, x, out=y1)
      _33 = torch.add(y1, c2, out=y1)
      _34 = torch.mul(y1, x, out=y1)
      _35 = torch.add(y1, c1, out=y1)
      const_0p5 = self.const_0p5
      _36 = torch.mul(const_0p5, y1, out=y1)
      _37 = torch.mul(y1, x, out=y1)
      _38 = torch.add(y1, y0, out=y1)
      _18 = y1
    return _18
  def is_resampling(self: __torch__.neutone_sdk.sandwich.Inplace4pHermiteResampler) -> bool:
    in_bs = self.in_bs
    out_bs = self.out_bs
    return torch.ne(in_bs, out_bs)
  def process_out(self: __torch__.neutone_sdk.sandwich.Inplace4pHermiteResampler,
    y: Tensor) -> Tensor:
    out_n_ch = self.out_n_ch
    out_bs = self.out_bs
    x_out = self.x_out
    y_m1_idx_out = self.y_m1_idx_out
    y0_idx_out = self.y0_idx_out
    y1_idx_out = self.y1_idx_out
    y2_idx_out = self.y2_idx_out
    y_m1_out = self.y_m1_out
    y0_out = self.y0_out
    y1_out = self.y1_out
    y2_out = self.y2_out
    c1_out = self.c1_out
    c2_out = self.c2_out
    c3_out = self.c3_out
    _39 = (self)._process_4p_hermite_opt(y, out_n_ch, out_bs, x_out, y_m1_idx_out, y0_idx_out, y1_idx_out, y2_idx_out, y_m1_out, y0_out, y1_out, y2_out, c1_out, c2_out, c3_out, )
    return _39
  def set_sample_rates(self: __torch__.neutone_sdk.sandwich.Inplace4pHermiteResampler,
    in_sr: int,
    out_sr: int,
    in_bs: int) -> NoneType:
    _40 = __torch__.neutone_sdk.sandwich.calc_x_and_indices
    self.in_sr = in_sr
    self.out_sr = out_sr
    self.in_bs = in_bs
    in_bs0 = self.in_bs
    out_sr0 = self.out_sr
    _41 = torch.mul(in_bs0, out_sr0)
    in_sr0 = self.in_sr
    self.out_bs = torch.ceil(torch.div(_41, in_sr0))
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      out_bs = self.out_bs
      if torch.gt(out_bs, 4):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    in_bs1 = self.in_bs
    out_bs0 = self.out_bs
    _42, _43, _44, = _40(in_bs1, out_bs0, )
    self.x_in = _42
    self.y0_idx_in = _43
    self.y1_idx_in = _44
    in_n_ch = self.in_n_ch
    out_bs1 = self.out_bs
    self.y0_in = torch.zeros([in_n_ch, out_bs1])
    in_n_ch0 = self.in_n_ch
    out_bs2 = self.out_bs
    self.y1_in = torch.zeros([in_n_ch0, out_bs2])
    out_bs3 = self.out_bs
    in_bs2 = self.in_bs
    _45, _46, _47, = _40(out_bs3, in_bs2, )
    self.x_out = _45
    self.y0_idx_out = _46
    self.y1_idx_out = _47
    out_n_ch = self.out_n_ch
    in_bs3 = self.in_bs
    self.y0_out = torch.zeros([out_n_ch, in_bs3])
    out_n_ch0 = self.out_n_ch
    in_bs4 = self.in_bs
    self.y1_out = torch.zeros([out_n_ch0, in_bs4])
    y0_idx_in = self.y0_idx_in
    _48 = torch.sub(y0_idx_in, 1)
    in_bs5 = self.in_bs
    _49 = torch.clamp(_48, 0, torch.sub(in_bs5, 1))
    self.y_m1_idx_in = _49
    y1_idx_in = self.y1_idx_in
    _50 = torch.add(y1_idx_in, 1)
    in_bs6 = self.in_bs
    _51 = torch.clamp(_50, 0, torch.sub(in_bs6, 1))
    self.y2_idx_in = _51
    in_n_ch1 = self.in_n_ch
    out_bs4 = self.out_bs
    self.y_m1_in = torch.zeros([in_n_ch1, out_bs4])
    in_n_ch2 = self.in_n_ch
    out_bs5 = self.out_bs
    self.y2_in = torch.zeros([in_n_ch2, out_bs5])
    in_n_ch3 = self.in_n_ch
    out_bs6 = self.out_bs
    self.c1_in = torch.zeros([in_n_ch3, out_bs6])
    in_n_ch4 = self.in_n_ch
    out_bs7 = self.out_bs
    self.c2_in = torch.zeros([in_n_ch4, out_bs7])
    in_n_ch5 = self.in_n_ch
    out_bs8 = self.out_bs
    self.c3_in = torch.zeros([in_n_ch5, out_bs8])
    y0_idx_out = self.y0_idx_out
    _52 = torch.sub(y0_idx_out, 1)
    out_bs9 = self.out_bs
    _53 = torch.clamp(_52, 0, torch.sub(out_bs9, 1))
    self.y_m1_idx_out = _53
    y1_idx_out = self.y1_idx_out
    _54 = torch.add(y1_idx_out, 1)
    out_bs10 = self.out_bs
    _55 = torch.clamp(_54, 0, torch.sub(out_bs10, 1))
    self.y2_idx_out = _55
    out_n_ch1 = self.out_n_ch
    in_bs7 = self.in_bs
    self.y_m1_out = torch.zeros([out_n_ch1, in_bs7])
    out_n_ch2 = self.out_n_ch
    in_bs8 = self.in_bs
    self.y2_out = torch.zeros([out_n_ch2, in_bs8])
    out_n_ch3 = self.out_n_ch
    in_bs9 = self.in_bs
    self.c1_out = torch.zeros([out_n_ch3, in_bs9])
    out_n_ch4 = self.out_n_ch
    in_bs10 = self.in_bs
    self.c2_out = torch.zeros([out_n_ch4, in_bs10])
    out_n_ch5 = self.out_n_ch
    in_bs11 = self.in_bs
    self.c3_out = torch.zeros([out_n_ch5, in_bs11])
    return None
class InplaceLinearResampler(Module):
  __parameters__ = []
  __buffers__ = []
  in_n_ch : int
  out_n_ch : int
  x_in : Tensor
  y0_idx_in : Tensor
  y1_idx_in : Tensor
  y0_in : Tensor
  y1_in : Tensor
  x_out : Tensor
  y0_idx_out : Tensor
  y1_idx_out : Tensor
  y0_out : Tensor
  y1_out : Tensor
  training : bool
  _is_full_backward_hook : Optional[bool]
  use_debug_mode : bool
  in_sr : int
  out_sr : int
  in_bs : int
  out_bs : int
  def process_in(self: __torch__.neutone_sdk.sandwich.InplaceLinearResampler,
    y: Tensor) -> Tensor:
    in_n_ch = self.in_n_ch
    in_bs = self.in_bs
    x_in = self.x_in
    y0_idx_in = self.y0_idx_in
    y1_idx_in = self.y1_idx_in
    y0_in = self.y0_in
    y1_in = self.y1_in
    _56 = (self)._process_2p_linear(y, in_n_ch, in_bs, x_in, y0_idx_in, y1_idx_in, y0_in, y1_in, )
    return _56
  def _process_2p_linear(self: __torch__.neutone_sdk.sandwich.InplaceLinearResampler,
    y: Tensor,
    n_ch: int,
    in_bs: int,
    x: Tensor,
    y0_idx: Tensor,
    y1_idx: Tensor,
    y0: Tensor,
    y1: Tensor) -> Tensor:
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      _57 = torch.eq(torch.size(y), [n_ch, in_bs])
      if _57:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    _58 = torch.__not__((self).is_resampling())
    if _58:
      _59 = y
    else:
      _60 = torch.index_select(y, 1, y0_idx, out=y0)
      _61 = torch.index_select(y, 1, y1_idx, out=y1)
      _62 = torch.sub(y1, y0, out=y1)
      _63 = torch.mul(y1, x, out=y1)
      _64 = torch.add(y0, y1, out=y0)
      _59 = y0
    return _59
  def is_resampling(self: __torch__.neutone_sdk.sandwich.InplaceLinearResampler) -> bool:
    in_bs = self.in_bs
    out_bs = self.out_bs
    return torch.ne(in_bs, out_bs)
  def set_sample_rates(self: __torch__.neutone_sdk.sandwich.InplaceLinearResampler,
    in_sr: int,
    out_sr: int,
    in_bs: int) -> NoneType:
    _65 = __torch__.neutone_sdk.sandwich.calc_x_and_indices
    self.in_sr = in_sr
    self.out_sr = out_sr
    self.in_bs = in_bs
    in_bs12 = self.in_bs
    out_sr1 = self.out_sr
    _66 = torch.mul(in_bs12, out_sr1)
    in_sr1 = self.in_sr
    self.out_bs = torch.ceil(torch.div(_66, in_sr1))
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      out_bs = self.out_bs
      if torch.ge(out_bs, 2):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    in_bs13 = self.in_bs
    out_bs11 = self.out_bs
    _67, _68, _69, = _65(in_bs13, out_bs11, )
    self.x_in = _67
    self.y0_idx_in = _68
    self.y1_idx_in = _69
    in_n_ch = self.in_n_ch
    out_bs12 = self.out_bs
    self.y0_in = torch.zeros([in_n_ch, out_bs12])
    in_n_ch6 = self.in_n_ch
    out_bs13 = self.out_bs
    self.y1_in = torch.zeros([in_n_ch6, out_bs13])
    out_bs14 = self.out_bs
    in_bs14 = self.in_bs
    _70, _71, _72, = _65(out_bs14, in_bs14, )
    self.x_out = _70
    self.y0_idx_out = _71
    self.y1_idx_out = _72
    out_n_ch = self.out_n_ch
    in_bs15 = self.in_bs
    self.y0_out = torch.zeros([out_n_ch, in_bs15])
    out_n_ch6 = self.out_n_ch
    in_bs16 = self.in_bs
    self.y1_out = torch.zeros([out_n_ch6, in_bs16])
    return None
def calc_x_and_indices(in_bs: int,
    out_bs: int) -> Tuple[Tensor, Tensor, Tensor]:
  _73 = torch.div(torch.sub(in_bs, 1), torch.sub(out_bs, 1))
  scaling_factor = torch.add(_73, 9.9999999999999998e-13)
  x = torch.mul(torch.arange(0, out_bs), scaling_factor)
  y0_idx = torch.to(torch.floor(x), 4)
  y1_idx = torch.add(y0_idx, 1)
  y1_idx0 = torch.clamp(y1_idx, 0, torch.sub(in_bs, 1))
  x2 = torch.clamp(torch.sub(x, y0_idx), 0., 1.)
  _74 = torch.select(x2, 0, 0)
  _75 = torch.tensor(0., dtype=ops.prim.dtype(_74), device=ops.prim.device(_74))
  _76 = torch.copy_(_74, _75)
  _77 = torch.round(torch.select(x2, 0, -1))
  _78 = torch.copy_(torch.select(x2, 0, -1), _77)
  return (x2, y0_idx, y1_idx0)
