class SampleQueueWrapper(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  use_debug_mode : bool
  in_n_ch : int
  out_n_ch : int
  daw_sr : int
  model_sr : int
  daw_bs : int
  io_bs : int
  model_bs : int
  seen_n : int
  is_queue_saturated : bool
  saturation_n : int
  in_queue : __torch__.neutone_sdk.queues.CircularInplaceTensorQueue
  params_queue : __torch__.neutone_sdk.queues.CircularInplaceTensorQueue
  out_queue : __torch__.neutone_sdk.queues.CircularInplaceTensorQueue
  daw_buffer : Tensor
  model_in_buffer : Tensor
  params_buffer : Tensor
  io_out_buffer : Tensor
  bt_out_buffer : Tensor
  w2w_base : __torch__.AcidSynthModelWrapper
  channel_normalizer : __torch__.neutone_sdk.sandwich.ChannelNormalizerSandwich
  resample_sandwich : __torch__.neutone_sdk.sandwich.Inplace4pHermiteResampler
  params_resample_sandwich : __torch__.neutone_sdk.sandwich.InplaceLinearResampler
  def forward(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper,
    x: Tensor,
    params: Optional[Tensor]=None) -> Tensor:
    is_daw_mono = torch.eq(torch.size(x, 0), 1)
    in_n = (torch.size(x))[1]
    channel_normalizer = self.channel_normalizer
    _0 = (self).is_input_mono()
    daw_buffer = self.daw_buffer
    x0 = (channel_normalizer).forward(x, _0, daw_buffer, )
    resample_sandwich = self.resample_sandwich
    x1 = (resample_sandwich).process_in(x0, )
    _1 = (self)._forward(x1, params, )
    is_queue_saturated = self.is_queue_saturated
    if is_queue_saturated:
      out_queue = self.out_queue
      io_out_buffer = self.io_out_buffer
      out_popped_n = (out_queue).pop(io_out_buffer, )
    else:
      io_out_buffer0 = self.io_out_buffer
      out_popped_n0 = torch.size(io_out_buffer0, 1)
      io_out_buffer1 = self.io_out_buffer
      _2 = torch.fill_(io_out_buffer1, 0)
      out_popped_n = out_popped_n0
    resample_sandwich0 = self.resample_sandwich
    io_out_buffer2 = self.io_out_buffer
    x2 = (resample_sandwich0).process_out(io_out_buffer2, )
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      io_out_buffer3 = self.io_out_buffer
      _3 = torch.eq(out_popped_n, torch.size(io_out_buffer3, 1))
      if _3:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      if torch.eq(torch.size(x2, 1), in_n):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    channel_normalizer0 = self.channel_normalizer
    daw_buffer0 = self.daw_buffer
    x3 = (channel_normalizer0).forward(x2, is_daw_mono, daw_buffer0, )
    return x3
  def calc_buffering_delay_samples(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> int:
    _4 = __torch__.neutone_sdk.sqw.calc_delay_samples
    io_bs = self.io_bs
    model_bs = self.model_bs
    delay_samples = _4(io_bs, model_bs, )
    if (self).is_resampling():
      daw_bs = self.daw_bs
      _5 = torch.mul(delay_samples, daw_bs)
      io_bs0 = self.io_bs
      delay_samples0 = int(torch.div(_5, io_bs0))
    else:
      delay_samples0 = delay_samples
    return delay_samples0
  def calc_model_delay_samples(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> int:
    w2w_base = self.w2w_base
    delay_samples = (w2w_base).calc_model_delay_samples()
    if (self).is_resampling():
      daw_bs = self.daw_bs
      _6 = torch.mul(delay_samples, daw_bs)
      io_bs = self.io_bs
      delay_samples1 = int(torch.div(_6, io_bs))
    else:
      delay_samples1 = delay_samples
    return delay_samples1
  def forward_bt(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper,
    x: Tensor,
    params: Optional[Tensor]=None) -> Optional[Tensor]:
    daw_n_ch = torch.size(x, 0)
    is_daw_mono = torch.eq(daw_n_ch, 1)
    channel_normalizer = self.channel_normalizer
    _7 = (self).is_input_mono()
    daw_buffer = self.daw_buffer
    x4 = (channel_normalizer).forward(x, _7, daw_buffer, )
    resample_sandwich = self.resample_sandwich
    x5 = (resample_sandwich).process_in(x4, )
    _8 = (self)._forward(x5, params, )
    is_queue_saturated = self.is_queue_saturated
    if is_queue_saturated:
      out_queue = self.out_queue
      size = out_queue.size
      io_bs = self.io_bs
      _9 = torch.ge(size, io_bs)
    else:
      _9 = False
    curr_n = 0
    _10 = _9
    while _10:
      out_queue0 = self.out_queue
      io_out_buffer = self.io_out_buffer
      out_popped_n = (out_queue0).pop(io_out_buffer, )
      use_debug_mode = self.use_debug_mode
      if use_debug_mode:
        io_bs1 = self.io_bs
        if torch.eq(out_popped_n, io_bs1):
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
      else:
        pass
      resample_sandwich1 = self.resample_sandwich
      io_out_buffer4 = self.io_out_buffer
      x6 = (resample_sandwich1).process_out(io_out_buffer4, )
      channel_normalizer1 = self.channel_normalizer
      daw_buffer1 = self.daw_buffer
      x7 = (channel_normalizer1).forward(x6, is_daw_mono, daw_buffer1, )
      use_debug_mode0 = self.use_debug_mode
      if use_debug_mode0:
        _11 = torch.size(x7, 1)
        daw_bs = self.daw_bs
        if torch.eq(_11, daw_bs):
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
        daw_bs0 = self.daw_bs
        _12 = torch.add(curr_n, daw_bs0)
        bt_out_buffer = self.bt_out_buffer
        _13 = torch.le(_12, torch.size(bt_out_buffer, 1))
        if _13:
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
      else:
        pass
      bt_out_buffer0 = self.bt_out_buffer
      _14 = torch.slice(bt_out_buffer0, 0, 0, daw_n_ch)
      daw_bs1 = self.daw_bs
      _15 = torch.slice(_14, 1, curr_n, torch.add(curr_n, daw_bs1))
      _16 = torch.copy_(_15, x7)
      daw_bs2 = self.daw_bs
      curr_n0 = torch.add(curr_n, daw_bs2)
      is_queue_saturated0 = self.is_queue_saturated
      if is_queue_saturated0:
        out_queue1 = self.out_queue
        size0 = out_queue1.size
        io_bs2 = self.io_bs
        _17 = torch.ge(size0, io_bs2)
      else:
        _17 = False
      _10, curr_n = _17, curr_n0
    if torch.eq(curr_n, 0):
      _18 : Optional[Tensor] = None
    else:
      bt_out_buffer1 = self.bt_out_buffer
      _19 = torch.slice(bt_out_buffer1, 0, 0, daw_n_ch)
      _18 = torch.slice(_19, 1, 0, curr_n)
    return _18
  def forward_offline(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper,
    x: Tensor,
    params: Optional[Tensor]=None) -> Tensor:
    _20 = (self).reset()
    _21 = (self).calc_buffering_delay_samples()
    delay_samples = torch.add(_21, (self).calc_model_delay_samples())
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      if torch.eq(torch.dim(x), 2):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      if torch.__isnot__(params, None):
        params2 = unchecked_cast(Tensor, params)
        if torch.eq(torch.dim(params2), 2):
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
        _22 = torch.eq(torch.size(x, 1), torch.size(params2, 1))
        if _22:
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
        params1 : Optional[Tensor] = params2
      else:
        params1 = params
      params0 : Optional[Tensor] = params1
    else:
      params0 = params
    n_samples = torch.size(x, 1)
    _23 = torch.add(n_samples, delay_samples)
    daw_bs = self.daw_bs
    _24 = torch.tensor(torch.div(_23, daw_bs))
    _25 = torch.ceil(_24)
    daw_bs3 = self.daw_bs
    padding_amount = torch.sub(torch.mul(_25, daw_bs3), n_samples)
    padding_amount0 = int(torch.item(padding_amount))
    padded_audio = torch.pad(x, [0, padding_amount0])
    daw_bs4 = self.daw_bs
    audio_chunks = torch.split(padded_audio, daw_bs4, 1)
    _26 = annotate(List[Tensor], [])
    if torch.__isnot__(params0, None):
      params4 = unchecked_cast(Tensor, params0)
      padded_params = torch.pad(params4, [0, padding_amount0], "replicate")
      daw_bs5 = self.daw_bs
      param_chunks0 = torch.split(padded_params, daw_bs5, 1)
      params3, param_chunks = params4, param_chunks0
    else:
      params3, param_chunks = params0, _26
    _27 = annotate(List[Tensor], [])
    _28 = [9223372036854775807, torch.len(audio_chunks)]
    params5: Optional[Tensor] = params3
    for idx in range(ops.prim.min(_28)):
      audio_chunk = audio_chunks[idx]
      if torch.__is__(params5, None):
        _29 = (self).forward(audio_chunk, None, )
        out, params6 = torch.clone(_29), params5
      else:
        params7 = unchecked_cast(Tensor, params5)
        param_chunk = param_chunks[idx]
        _30 = (self).forward(audio_chunk, param_chunk, )
        out, params6 = torch.clone(_30), params7
      _31 = torch.append(_27, out)
      params5 = params6
    audio_out = torch.cat(_27, 1)
    audio_out0 = torch.slice(torch.slice(audio_out), 1, torch.neg(n_samples))
    return audio_out0
  def get_default_param_descriptions(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> List[str]:
    w2w_base = self.w2w_base
    _32 = (w2w_base).get_default_param_descriptions()
    return _32
  def get_default_param_names(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> List[str]:
    w2w_base = self.w2w_base
    _33 = (w2w_base).get_default_param_names()
    return _33
  def get_default_param_types(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> List[str]:
    w2w_base = self.w2w_base
    _34 = (w2w_base).get_default_param_types()
    return _34
  def get_default_param_used(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> List[bool]:
    w2w_base = self.w2w_base
    return (w2w_base).get_default_param_used()
  def get_default_param_values(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> Tensor:
    w2w_base = self.w2w_base
    _35 = (w2w_base).get_default_param_values()
    return _35
  def get_dry_default_value(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> float:
    w2w_base = self.w2w_base
    return (w2w_base).get_dry_default_value()
  def get_input_gain_default_value(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> float:
    w2w_base = self.w2w_base
    _36 = (w2w_base).get_input_gain_default_value()
    return _36
  def get_model_authors(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> List[str]:
    w2w_base = self.w2w_base
    return (w2w_base).get_model_authors()
  def get_model_name(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> str:
    w2w_base = self.w2w_base
    return (w2w_base).get_model_name()
  def get_native_buffer_sizes(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> List[int]:
    w2w_base = self.w2w_base
    _37 = (w2w_base).get_native_buffer_sizes()
    return _37
  def get_native_sample_rates(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> List[int]:
    w2w_base = self.w2w_base
    _38 = (w2w_base).get_native_sample_rates()
    return _38
  def get_output_gain_default_value(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> float:
    w2w_base = self.w2w_base
    _39 = (w2w_base).get_output_gain_default_value()
    return _39
  def get_preserved_attributes(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> List[str]:
    _40 = "set_daw_sample_rate_and_buffer_size"
    _41 = ["forward_bt", "is_input_mono", "is_output_mono", "get_model_name", "get_model_authors", "get_native_sample_rates", "get_native_buffer_sizes", "get_wet_default_value", "get_dry_default_value", "get_default_param_values", "get_input_gain_default_value", "get_output_gain_default_value", "is_resampling", "calc_buffering_delay_samples", "calc_model_delay_samples", _40, "reset", "get_preserved_attributes", "to_metadata", "w2w_base"]
    return _41
  def get_wet_default_value(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> float:
    w2w_base = self.w2w_base
    return (w2w_base).get_wet_default_value()
  def is_input_mono(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> bool:
    w2w_base = self.w2w_base
    return (w2w_base).is_input_mono()
  def is_output_mono(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> bool:
    w2w_base = self.w2w_base
    return (w2w_base).is_output_mono()
  def is_resampling(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> bool:
    resample_sandwich = self.resample_sandwich
    return (resample_sandwich).is_resampling()
  def reset(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> NoneType:
    w2w_base = self.w2w_base
    _42 = (w2w_base).reset()
    in_queue = self.in_queue
    _43 = (in_queue).reset()
    params_queue = self.params_queue
    _44 = (params_queue).reset()
    out_queue = self.out_queue
    _45 = (out_queue).reset()
    daw_buffer = self.daw_buffer
    _46 = torch.fill_(daw_buffer, 0)
    model_in_buffer = self.model_in_buffer
    _47 = torch.fill_(model_in_buffer, 0)
    params_buffer = self.params_buffer
    _48 = torch.fill_(params_buffer, 0)
    io_out_buffer = self.io_out_buffer
    _49 = torch.fill_(io_out_buffer, 0)
    bt_out_buffer = self.bt_out_buffer
    _50 = torch.fill_(bt_out_buffer, 0)
    self.seen_n = 0
    self.is_queue_saturated = False
    return None
  def set_daw_sample_rate_and_buffer_size(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper,
    daw_sr: int,
    daw_bs: int,
    model_sr: Optional[int]=None,
    model_bs: Optional[int]=None) -> int:
    _51 = __torch__.neutone_sdk.sqw.select_best_model_sr
    _52 = __torch__.neutone_sdk.sqw.calc_resampled_buffer_size
    _53 = __torch__.neutone_sdk.sqw.select_best_model_buffer_size
    _54 = __torch__.neutone_sdk.sqw.calc_max_daw_queue_size
    _55 = __torch__.neutone_sdk.sqw.calc_saturation_n
    if torch.__isnot__(model_sr, None):
      model_sr1 = unchecked_cast(int, model_sr)
      use_debug_mode = self.use_debug_mode
      if use_debug_mode:
        _56 = (self).get_native_sample_rates()
        if torch.eq(torch.len(_56), 0):
          _57 = True
        else:
          _58 = (self).get_native_sample_rates()
          _59 = torch.__contains__(_58, model_sr1)
          _57 = _59
        if _57:
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
      else:
        pass
      model_sr0 = model_sr1
    else:
      model_sr2 = _51(daw_sr, (self).get_native_sample_rates(), )
      model_sr0 = model_sr2
    io_bs = _52(daw_sr, model_sr0, daw_bs, )
    resample_sandwich = self.resample_sandwich
    _60 = (resample_sandwich).set_sample_rates(daw_sr, model_sr0, daw_bs, )
    params_resample_sandwich = self.params_resample_sandwich
    _61 = (params_resample_sandwich).set_sample_rates(daw_sr, model_sr0, daw_bs, )
    self.daw_sr = daw_sr
    self.model_sr = model_sr0
    if torch.__isnot__(model_bs, None):
      model_bs1 = unchecked_cast(int, model_bs)
      use_debug_mode1 = self.use_debug_mode
      if use_debug_mode1:
        _62 = (self).get_native_buffer_sizes()
        if torch.eq(torch.len(_62), 0):
          _63 = True
        else:
          _64 = (self).get_native_buffer_sizes()
          _65 = torch.__contains__(_64, model_bs1)
          _63 = _65
        if _63:
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
      else:
        pass
      model_bs0 = model_bs1
    else:
      model_bs2 = _53(io_bs, (self).get_native_buffer_sizes(), )
      model_bs0 = model_bs2
    w2w_base = self.w2w_base
    _66 = (w2w_base).set_sample_rate_and_buffer_size(model_sr0, model_bs0, )
    self.daw_bs = daw_bs
    self.io_bs = io_bs
    self.model_bs = model_bs0
    in_n_ch = self.in_n_ch
    io_bs3 = self.io_bs
    _67 = torch.mul(2, io_bs3)
    model_bs3 = self.model_bs
    _68 = torch.add(_67, model_bs3)
    use_debug_mode2 = self.use_debug_mode
    _69 = __torch__.neutone_sdk.queues.CircularInplaceTensorQueue.__new__(__torch__.neutone_sdk.queues.CircularInplaceTensorQueue)
    _70 = (_69).__init__(in_n_ch, _68, use_debug_mode2, )
    self.in_queue = _69
    w2w_base0 = self.w2w_base
    MAX_N_PARAMS = w2w_base0.MAX_N_PARAMS
    io_bs4 = self.io_bs
    _71 = torch.mul(2, io_bs4)
    model_bs4 = self.model_bs
    _72 = torch.add(_71, model_bs4)
    use_debug_mode3 = self.use_debug_mode
    _73 = __torch__.neutone_sdk.queues.CircularInplaceTensorQueue.__new__(__torch__.neutone_sdk.queues.CircularInplaceTensorQueue)
    _74 = (_73).__init__(MAX_N_PARAMS, _72, use_debug_mode3, )
    self.params_queue = _73
    out_n_ch = self.out_n_ch
    io_bs5 = self.io_bs
    _75 = torch.mul(2, io_bs5)
    model_bs5 = self.model_bs
    _76 = torch.add(_75, model_bs5)
    use_debug_mode4 = self.use_debug_mode
    _77 = __torch__.neutone_sdk.queues.CircularInplaceTensorQueue.__new__(__torch__.neutone_sdk.queues.CircularInplaceTensorQueue)
    _78 = (_77).__init__(out_n_ch, _76, use_debug_mode4, )
    self.out_queue = _77
    daw_bs6 = self.daw_bs
    self.daw_buffer = torch.zeros([2, daw_bs6])
    in_n_ch0 = self.in_n_ch
    model_bs6 = self.model_bs
    self.model_in_buffer = torch.zeros([in_n_ch0, model_bs6])
    w2w_base1 = self.w2w_base
    MAX_N_PARAMS0 = w2w_base1.MAX_N_PARAMS
    model_bs7 = self.model_bs
    _79 = torch.zeros([MAX_N_PARAMS0, model_bs7])
    self.params_buffer = _79
    out_n_ch0 = self.out_n_ch
    io_bs6 = self.io_bs
    self.io_out_buffer = torch.zeros([out_n_ch0, io_bs6])
    daw_sr0 = self.daw_sr
    daw_bs7 = self.daw_bs
    model_sr3 = self.model_sr
    model_bs8 = self.model_bs
    max_daw_queue_size = _54(daw_sr0, daw_bs7, model_sr3, model_bs8, )
    _80 = torch.zeros([2, max_daw_queue_size])
    self.bt_out_buffer = _80
    io_bs7 = self.io_bs
    model_bs9 = self.model_bs
    self.saturation_n = _55(io_bs7, model_bs9, )
    _81 = (self).reset()
    return max_daw_queue_size
  def to_metadata(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper) -> __torch__.neutone_sdk.wavform_to_wavform.WaveformToWaveformMetadata:
    w2w_base = self.w2w_base
    return (w2w_base).to_metadata()
  def _forward(self: __torch__.neutone_sdk.sqw.SampleQueueWrapper,
    resampled_x: Tensor,
    params: Optional[Tensor]=None) -> NoneType:
    _82 = __torch__.neutone_sdk.utils.validate_waveform
    if torch.__isnot__(params, None):
      params8 = unchecked_cast(Tensor, params)
      params_resample_sandwich = self.params_resample_sandwich
      params9 = (params_resample_sandwich).process_in(params8, )
      params_queue = self.params_queue
      _83 = (params_queue).push(params9, )
    else:
      pass
    resampled_in_n = torch.size(resampled_x, 1)
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      io_bs = self.io_bs
      if torch.eq(resampled_in_n, io_bs):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    in_queue = self.in_queue
    _84 = (in_queue).push(resampled_x, )
    is_queue_saturated = self.is_queue_saturated
    if torch.__not__(is_queue_saturated):
      seen_n = self.seen_n
      self.seen_n = torch.add(seen_n, resampled_in_n)
      seen_n0 = self.seen_n
      saturation_n = self.saturation_n
      if torch.ge(seen_n0, saturation_n):
        self.is_queue_saturated = True
      else:
        pass
    else:
      pass
    in_queue0 = self.in_queue
    size = in_queue0.size
    model_bs = self.model_bs
    _85 = torch.ge(size, model_bs)
    while _85:
      in_queue1 = self.in_queue
      model_in_buffer = self.model_in_buffer
      in_popped_n = (in_queue1).pop(model_in_buffer, )
      use_debug_mode5 = self.use_debug_mode
      if use_debug_mode5:
        model_bs7 = self.model_bs
        _86 = torch.eq(in_popped_n, model_bs7)
        if _86:
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
        model_in_buffer0 = self.model_in_buffer
        _87 = _82(model_in_buffer0, (self).is_input_mono(), )
      else:
        pass
      params_queue0 = self.params_queue
      if (params_queue0).is_empty():
        w2w_base = self.w2w_base
        model_in_buffer1 = self.model_in_buffer
        model_out0 = (w2w_base).forward(model_in_buffer1, None, )
        model_out = model_out0
      else:
        params_queue1 = self.params_queue
        params_buffer = self.params_buffer
        params_popped_n = (params_queue1).pop(params_buffer, )
        use_debug_mode6 = self.use_debug_mode
        if use_debug_mode6:
          _88 = torch.eq(params_popped_n, in_popped_n)
          if _88:
            pass
          else:
            ops.prim.RaiseException("AssertionError: ")
        else:
          pass
        w2w_base2 = self.w2w_base
        model_in_buffer2 = self.model_in_buffer
        params_buffer0 = self.params_buffer
        model_out1 = (w2w_base2).forward(model_in_buffer2, params_buffer0, )
        model_out = model_out1
      use_debug_mode7 = self.use_debug_mode
      if use_debug_mode7:
        _89 = _82(model_out, (self).is_output_mono(), )
      else:
        pass
      out_queue = self.out_queue
      _90 = (out_queue).push(model_out, )
      in_queue2 = self.in_queue
      size1 = in_queue2.size
      model_bs8 = self.model_bs
      _85 = torch.ge(size1, model_bs8)
    return None
def calc_delay_samples(io_bs: int,
    model_bs: int) -> int:
  _91 = __torch__.neutone_sdk.sqw.calc_saturation_n
  saturation_n = _91(io_bs, model_bs, )
  return torch.sub(saturation_n, io_bs)
def select_best_model_sr(daw_sr: int,
    native_sample_rates: List[int]) -> int:
  _92 = torch.gt(torch.len(native_sample_rates), 0)
  if torch.__not__(_92):
    _93 = daw_sr
  else:
    _94 = torch.__contains__(native_sample_rates, daw_sr)
    if _94:
      _95 = daw_sr
    else:
      _96 = torch.eq(torch.len(native_sample_rates), 1)
      if _96:
        _97 = native_sample_rates[0]
      else:
        diffs = annotate(List[int], [])
        for _98 in range(torch.len(native_sample_rates)):
          sr = native_sample_rates[_98]
          _99 = ops.prim.abs(torch.sub(sr, daw_sr))
          _100 = torch.append(diffs, _99)
        min_idx = torch.index(diffs, ops.prim.min(diffs))
        _97 = native_sample_rates[min_idx]
      _95 = _97
    _93 = _95
  return _93
def calc_resampled_buffer_size(orig_sr: int,
    new_sr: int,
    orig_bs: int) -> int:
  if torch.eq(orig_sr, new_sr):
    resampled_bs = orig_bs
  else:
    _101 = torch.div(torch.mul(new_sr, orig_bs), orig_sr)
    resampled_bs = torch.ceil(_101)
  return resampled_bs
def select_best_model_buffer_size(io_bs: int,
    native_buffer_sizes: List[int]) -> int:
  _102 = uninitialized(int)
  _103 = torch.gt(torch.len(native_buffer_sizes), 0)
  if torch.__not__(_103):
    _104 = io_bs
  else:
    _105 = torch.eq(torch.len(native_buffer_sizes), 1)
    if _105:
      _106 = native_buffer_sizes[0]
    else:
      native_buffer_sizes0 = sorted(native_buffer_sizes)
      _107 = torch.len(native_buffer_sizes0)
      _108 = False
      _109 = _102
      _110 = 0
      _111 = torch.gt(_107, 0)
      while _111:
        bs = native_buffer_sizes0[_110]
        _112 = torch.eq(torch.remainder(bs, io_bs), 0)
        if _112:
          _113, _114, _115 = False, True, bs
        else:
          _113, _114, _115 = True, False, _102
        _116 = torch.add(_110, 1)
        _117 = torch.__and__(torch.lt(_116, _107), _113)
        _111, _108, _109, _110 = _117, _114, _115, _116
      if _108:
        _118 = _109
      else:
        _119 = torch.len(native_buffer_sizes0)
        _120 = False
        _121 = _102
        _122 = 0
        _123 = torch.gt(_119, 0)
        while _123:
          bs0 = native_buffer_sizes0[_122]
          if torch.gt(bs0, io_bs):
            _124, _125, _126 = False, True, bs0
          else:
            _124, _125, _126 = True, False, _102
          _127 = torch.add(_122, 1)
          _128 = torch.__and__(torch.lt(_127, _119), _124)
          _123, _120, _121, _122 = _128, _125, _126, _127
        if _120:
          _129 = _121
        else:
          diffs = annotate(List[int], [])
          _130 = torch.len(native_buffer_sizes0)
          for _131 in range(_130):
            bs1 = native_buffer_sizes0[_131]
            _132 = ops.prim.abs(torch.sub(bs1, io_bs))
            _133 = torch.append(diffs, _132)
          min_idx = torch.index(diffs, ops.prim.min(diffs))
          _129 = native_buffer_sizes0[min_idx]
        _118 = _129
      _106 = _118
    _104 = _106
  return _104
def calc_max_daw_queue_size(daw_sr: int,
    daw_bs: int,
    model_sr: int,
    model_bs: int) -> int:
  _134 = torch.div(torch.mul(model_bs, daw_sr), model_sr)
  daw_model_bs = torch.add(int(_134), 1)
  _135 = torch.add(torch.mul(2, daw_bs), daw_model_bs)
  return _135
def calc_saturation_n(io_bs: int,
    model_bs: int) -> int:
  _136 = __torch__.neutone_sdk.sqw._calc_saturation_n_case_3_and_4
  _137 = torch.eq(torch.remainder(model_bs, io_bs), 0)
  if _137:
    _138 = model_bs
  else:
    _139 = torch.eq(torch.remainder(io_bs, model_bs), 0)
    if _139:
      _140 = io_bs
    else:
      _140 = _136(io_bs, model_bs, )
    _138 = _140
  return _138
def _calc_saturation_n_case_3_and_4(io_bs: int,
    model_bs: int) -> int:
  io_bs_t = torch.tensor(io_bs)
  model_bs_t = torch.tensor(model_bs)
  lcm = torch.item(torch.lcm(io_bs_t, model_bs_t))
  remainders = torch.remainder(torch.arange(0, lcm, io_bs), model_bs)
  max_remainder = torch.max(remainders)
  _141 = torch.ceil(torch.div(max_remainder, io_bs))
  n_io_bufs_in_max_remainder = torch.item(torch.to(_141, 3))
  _142 = torch.mul(n_io_bufs_in_max_remainder, io_bs)
  saturation_n = torch.add(io_bs, _142)
  return int(saturation_n)
