def make_envelope(x: Tensor,
    note_on_samples: int,
    curr_env_val: float) -> Tuple[Tensor, int, float]:
  n_samples = torch.size(x, -1)
  n_env = torch.floordiv(torch.mul(2, n_samples), note_on_samples)
  n_env0 = ops.prim.max(n_env, 2)
  env = torch.linspace(1., 0., note_on_samples)
  env0 = torch.repeat(env, [n_env0])
  out = torch.zeros([1, n_samples])
  non_zero_indices = torch.nonzero(torch.squeeze(x))
  _0 = torch.gt(torch.size(non_zero_indices, 0), 0)
  if _0:
    _1 = torch.select(non_zero_indices, 0, 0)
    first_nonzero_idx0 = torch.item(torch.select(_1, 0, 0))
    first_nonzero_idx = int(first_nonzero_idx0)
  else:
    first_nonzero_idx = -1
  if torch.eq(first_nonzero_idx, -1):
    _2 = torch.eq(curr_env_val, 0.)
  else:
    _2 = False
  if _2:
    _3 = (out, 0, curr_env_val)
  else:
    if torch.ne(curr_env_val, 0.):
      _4 = torch.mul(torch.sub(1., curr_env_val), torch.sub(note_on_samples, 1))
      cont_env_start_idx0 = int(torch.round(_4))
      cont_env_start_idx1 = ops.prim.min(cont_env_start_idx0, torch.sub(note_on_samples, 1))
      cont_env_start_idx2 = ops.prim.max(cont_env_start_idx1, 0)
      cont_env_start_idx = cont_env_start_idx2
    else:
      cont_env_start_idx = 0
    if torch.eq(first_nonzero_idx, 0):
      _6 = torch.add(cont_env_start_idx, n_samples)
      _7 = torch.slice(env0, 0, cont_env_start_idx, _6)
      _8 = torch.slice(torch.slice(out), 1, 0, n_samples)
      _9 = torch.copy_(_8, _7)
      _10 = torch.select(torch.select(out, 0, 0), 0, -1)
      curr_env_val0 = torch.item(_10)
      _11 = (out, first_nonzero_idx, float(curr_env_val0))
      _5 = _11
    else:
      if torch.ne(curr_env_val, 0.):
        _12 = torch.sub(note_on_samples, cont_env_start_idx)
        cont_env_len0 = ops.prim.min(n_samples, _12)
        cont_env_end_idx = torch.add(cont_env_start_idx, cont_env_len0)
        _13 = torch.slice(env0, 0, cont_env_start_idx, cont_env_end_idx)
        _14 = torch.slice(torch.slice(out), 1, 0, cont_env_len0)
        _15 = torch.copy_(_14, _13)
        cont_env_len = cont_env_len0
      else:
        cont_env_len = 0
      if torch.eq(first_nonzero_idx, -1):
        _17 = torch.select(torch.select(out, 0, 0), 0, -1)
        curr_env_val1 = torch.item(_17)
        _16 = (out, 0, float(curr_env_val1))
      else:
        first_nonzero_idx1 = ops.prim.max(first_nonzero_idx, cont_env_len)
        n_non_zero_samples = torch.sub(n_samples, first_nonzero_idx1)
        _18 = torch.slice(env0, 0, 0, n_non_zero_samples)
        _19 = torch.slice(torch.slice(out), 1, first_nonzero_idx1, n_samples)
        _20 = torch.copy_(_19, _18)
        _21 = torch.select(torch.select(out, 0, 0), 0, -1)
        curr_env_val2 = torch.item(_21)
        _22 = (out, first_nonzero_idx1, float(curr_env_val2))
        _16 = _22
      _5 = _16
    _3 = _5
  return _3
