class AcidSynthLPBiquadFSM(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  ac : __torch__.audio_config.AudioConfig
  interp_coeff : bool
  is_scriptable : bool
  vco : __torch__.acid_ddsp.synth_modules.SquareSawVCOLite
  env_gen : __torch__.acid_ddsp.synth_modules.ExpDecayEnv
  filter : __torch__.filters.TimeVaryingLPBiquadFSM
  def forward(self: __torch__.synths.AcidSynthLPBiquadFSM,
    n_samples: int,
    f0_hz: Tensor,
    note_on_duration: Tensor,
    phase: Tensor,
    filter_args: Dict[str, Tensor],
    global_params: Dict[str, Tensor],
    envelope: Optional[Tensor]=None) -> Dict[str, Tensor]:
    osc_shape = torch.get(global_params, "osc_shape")
    if torch.__is__(osc_shape, None):
      ac = self.ac
      if (ac).is_fixed("osc_shape", ):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      ac0 = self.ac
      min_osc_shape = ac0.min_osc_shape
      osc_shape1 = torch.full_like(f0_hz, min_osc_shape)
      osc_shape0 = osc_shape1
    else:
      osc_shape0 = unchecked_cast(Tensor, osc_shape)
    osc_gain = torch.get(global_params, "osc_gain")
    if torch.__is__(osc_gain, None):
      ac1 = self.ac
      if (ac1).is_fixed("osc_gain", ):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      ac2 = self.ac
      min_osc_gain = ac2.min_osc_gain
      osc_gain1 = torch.full_like(f0_hz, min_osc_gain)
      osc_gain0 = osc_gain1
    else:
      osc_gain0 = unchecked_cast(Tensor, osc_gain)
    dist_gain = torch.get(global_params, "dist_gain")
    if torch.__is__(dist_gain, None):
      ac3 = self.ac
      if (ac3).is_fixed("dist_gain", ):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      ac4 = self.ac
      min_dist_gain = ac4.min_dist_gain
      dist_gain1 = torch.full_like(f0_hz, min_dist_gain)
      dist_gain0 = dist_gain1
    else:
      dist_gain0 = unchecked_cast(Tensor, dist_gain)
    learned_alpha = torch.get(global_params, "learned_alpha")
    if torch.__is__(learned_alpha, None):
      ac5 = self.ac
      if (ac5).is_fixed("learned_alpha", ):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      ac6 = self.ac
      min_learned_alpha = ac6.min_learned_alpha
      learned_alpha1 = torch.full_like(f0_hz, min_learned_alpha)
      learned_alpha0 = learned_alpha1
    else:
      learned_alpha2 = unchecked_cast(Tensor, learned_alpha)
      learned_alpha0 = learned_alpha2
    _0 = torch.eq(torch.size(note_on_duration), torch.size(osc_shape0))
    if _0:
      _2 = torch.eq(torch.size(osc_shape0), torch.size(osc_gain0))
      _1 = _2
    else:
      _1 = False
    if _1:
      _4 = torch.eq(torch.size(osc_gain0), torch.size(dist_gain0))
      _3 = _4
    else:
      _3 = False
    if _3:
      _6 = torch.eq(torch.size(dist_gain0), torch.size(learned_alpha0))
      _5 = _6
    else:
      _5 = False
    if _5:
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    vco = self.vco
    dry_audio = (vco).forward(f0_hz, osc_shape0, n_samples, phase, )
    dry_audio0 = torch.mul_(dry_audio, torch.unsqueeze(osc_gain0, -1))
    if torch.__is__(envelope, None):
      env_gen = self.env_gen
      envelope1 = (env_gen).forward(learned_alpha0, note_on_duration, n_samples, )
      envelope0 = envelope1
    else:
      envelope0 = unchecked_cast(Tensor, envelope)
    dry_audio1 = torch.mul_(dry_audio0, envelope0)
    _7 = (self).filter_dry_audio(dry_audio1, filter_args, )
    filtered_audio, filter_out, = _7
    wet_audio = torch.mul(filtered_audio, torch.unsqueeze(dist_gain0, -1))
    wet_audio0 = torch.tanh(wet_audio)
    synth_out = {"dry": dry_audio1, "wet": wet_audio0, "envelope": envelope0, "filtered_audio": filtered_audio}
    torch.update(synth_out, filter_out)
    return synth_out
  def filter_dry_audio(self: __torch__.synths.AcidSynthLPBiquadFSM,
    x: Tensor,
    filter_args: Dict[str, Tensor]) -> Tuple[Tensor, Dict[str, Tensor]]:
    w_mod_sig = filter_args["w_mod_sig"]
    q_mod_sig = filter_args["q_mod_sig"]
    zi = torch.get(filter_args, "zi")
    if torch.eq(torch.dim(w_mod_sig), 3):
      w_mod_sig0 = torch.squeeze(w_mod_sig, 2)
    else:
      w_mod_sig0 = w_mod_sig
    if torch.eq(torch.dim(q_mod_sig), 3):
      q_mod_sig0 = torch.squeeze(q_mod_sig, 2)
    else:
      q_mod_sig0 = q_mod_sig
    filter = self.filter
    interp_coeff = self.interp_coeff
    _8 = (filter).forward(x, w_mod_sig0, q_mod_sig0, interp_coeff, zi, )
    y, a_coeff, b_coeff, y_a, = _8
    filter_out = {"a_coeff": a_coeff, "b_coeff": b_coeff}
    if torch.__isnot__(y_a, None):
      y_a0 = unchecked_cast(Tensor, y_a)
      torch._set_item(filter_out, "y_a", y_a0)
    else:
      pass
    return (y, filter_out)
