def layer_norm(input: Tensor,
    normalized_shape: List[int],
    weight: Optional[Tensor]=None,
    bias: Optional[Tensor]=None,
    eps: float=1.0000000000000001e-05) -> Tensor:
  _0 = torch.layer_norm(input, normalized_shape, weight, bias, eps)
  return _0
def _max_pool2d(input: Tensor,
    kernel_size: List[int],
    stride: Optional[List[int]]=None,
    padding: List[int]=[0, 0],
    dilation: List[int]=[1, 1],
    ceil_mode: bool=False,
    return_indices: bool=False) -> Tensor:
  if torch.__is__(stride, None):
    stride0 = annotate(List[int], [])
  else:
    stride0 = unchecked_cast(List[int], stride)
  _1 = torch.max_pool2d(input, kernel_size, stride0, padding, dilation, ceil_mode)
  return _1
def dropout(input: Tensor,
    p: float=0.5,
    training: bool=True,
    inplace: bool=False) -> Tensor:
  _2 = "dropout probability has to be between 0 and 1, but got {}"
  if torch.lt(p, 0.):
    _3 = True
  else:
    _3 = torch.gt(p, 1.)
  if _3:
    ops.prim.RaiseException(torch.format(_2, p), "builtins.ValueError")
  else:
    pass
  if inplace:
    _4 = torch.dropout_(input, p, training)
  else:
    _4 = torch.dropout(input, p, training)
  return _4
def interpolate(input: Tensor,
    size: Optional[int]=None,
    scale_factor: Optional[List[float]]=None,
    mode: str="nearest",
    align_corners: Optional[bool]=None,
    recompute_scale_factor: Optional[bool]=None,
    antialias: bool=False) -> Tensor:
  _5 = "align_corners option can only be set with the interpolating modes: linear | bilinear | bicubic | trilinear"
  _6 = "only one of size or scale_factor should be defined"
  _7 = "Input and scale_factor must have the same number of spatial dimensions, but got input with spatial dimensions of {} and scale_factor of shape {}. Please provide input tensor in (N, C, d1, d2, ...,dK) format and scale_factor in (s1, s2, ...,sK) format."
  _8 = "either size or scale_factor should be defined"
  _9 = "recompute_scale_factor is not meaningful with an explicit size."
  _10 = "Anti-alias option is only supported for bilinear and bicubic modes"
  _11 = __torch__.torch.nn.functional.adaptive_avg_pool2d
  _12 = __torch__.torch.nn.functional.adaptive_avg_pool3d
  _13 = "Got 3D input, but bilinear mode needs 4D input"
  _14 = "Got 3D input, but trilinear mode needs 5D input"
  _15 = "Got 4D input, but linear mode needs 3D input"
  _16 = "Got 4D input, but trilinear mode needs 5D input"
  _17 = "Got 5D input, but linear mode needs 3D input"
  _18 = "Got 5D input, but bilinear mode needs 4D input"
  _19 = "Input Error: Only 3D, 4D and 5D input Tensors supported (got {}D) for the modes: nearest | linear | bilinear | bicubic | trilinear | area | nearest-exact (got {})"
  _20 = uninitialized(Tensor)
  _21 = uninitialized(List[int])
  _22 = uninitialized(Optional[bool])
  _23 = uninitialized(NoneType)
  _24 = uninitialized(List[float])
  _25 = uninitialized(Optional[List[int]])
  _26 = uninitialized(Optional[List[float]])
  _27 = uninitialized(Optional[int])
  _28 = uninitialized(Optional[bool])
  _29 = uninitialized(bool)
  _30 = torch.__contains__(["nearest", "area", "nearest-exact"], mode)
  if _30:
    _31 = torch.__isnot__(align_corners, None)
    if _31:
      ops.prim.RaiseException(_5, "builtins.ValueError")
      align_corners1 : Optional[bool] = _28
    else:
      align_corners1 = align_corners
    align_corners0 : Optional[bool] = align_corners1
  else:
    if torch.__is__(align_corners, None):
      align_corners2 = False
    else:
      align_corners3 = unchecked_cast(bool, align_corners)
      align_corners2 = align_corners3
    align_corners0 = align_corners2
  dim = torch.sub(torch.dim(input), 2)
  if torch.__isnot__(size, None):
    size1 = unchecked_cast(int, size)
    _32, size0 = torch.__isnot__(scale_factor, None), size1
  else:
    _32, size0 = False, size
  if _32:
    ops.prim.RaiseException(_6, "builtins.ValueError")
    size2, output_size, scale_factors = _27, _25, _26
  else:
    if torch.__isnot__(size0, None):
      size4 = unchecked_cast(int, size0)
      if torch.__is__(scale_factor, None):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      size5 = unchecked_cast(int, size4)
      output_size1 = annotate(List[int], [])
      for _33 in range(dim):
        _34 = torch.append(output_size1, size5)
      size3, output_size0, scale_factors0 = size5, output_size1, None
    else:
      _35 = torch.__isnot__(scale_factor, None)
      if _35:
        scale_factor0 = unchecked_cast(List[float], scale_factor)
        if torch.__is__(size0, None):
          size7 : Optional[int] = size0
        else:
          ops.prim.RaiseException("AssertionError: ")
          size7 = _27
        scale_factor1 = unchecked_cast(List[float], scale_factor0)
        _36 = torch.ne(torch.len(scale_factor1), dim)
        if _36:
          _37 = torch.slice(torch.size(input), 2)
          _38 = torch.format(_7, torch.list(_37), scale_factor1)
          ops.prim.RaiseException(_38, "builtins.ValueError")
        else:
          pass
        size6, output_size2, scale_factors1 = size7, None, scale_factor1
      else:
        ops.prim.RaiseException(_8, "builtins.ValueError")
        size6, output_size2, scale_factors1 = _27, _23, _24
      size3, output_size0, scale_factors0 = size6, output_size2, scale_factors1
    size2, output_size, scale_factors = size3, output_size0, scale_factors0
  _39 = torch.__isnot__(recompute_scale_factor, None)
  if _39:
    recompute_scale_factor1 = unchecked_cast(bool, recompute_scale_factor)
    _40, recompute_scale_factor0 = recompute_scale_factor1, recompute_scale_factor1
  else:
    _40, recompute_scale_factor0 = False, recompute_scale_factor
  if _40:
    recompute_scale_factor3 = unchecked_cast(bool, recompute_scale_factor0)
    _41, recompute_scale_factor2 = torch.__isnot__(size2, None), recompute_scale_factor3
  else:
    _41, recompute_scale_factor2 = False, recompute_scale_factor0
  if _41:
    ops.prim.RaiseException(_9, "builtins.ValueError")
    recompute_scale_factor4 : Optional[bool] = _22
  else:
    recompute_scale_factor4 = recompute_scale_factor2
  if torch.eq(mode, "area"):
    _42 = torch.__is__(output_size, None)
  else:
    _42 = False
  if _42:
    recompute_scale_factor5 : Optional[bool] = True
  else:
    recompute_scale_factor5 = recompute_scale_factor4
  _43 = torch.__isnot__(recompute_scale_factor5, None)
  if _43:
    recompute_scale_factor6 = unchecked_cast(bool, recompute_scale_factor5)
    _44 = recompute_scale_factor6
  else:
    _44 = False
  if _44:
    _45 = torch.__isnot__(scale_factors, None)
    if _45:
      scale_factors4 = unchecked_cast(List[float], scale_factors)
      scale_factors3 = scale_factors4
    else:
      ops.prim.RaiseException("AssertionError: ")
      scale_factors3 = _24
    output_size4 = annotate(List[int], [])
    for i in range(dim):
      _46 = torch.size(input, torch.add(i, 2))
      _47 = torch.mul(float(_46), scale_factors3[i])
      _48 = torch.append(output_size4, torch.floor(_47))
    output_size3, scale_factors2 = output_size4, None
  else:
    output_size3, scale_factors2 = output_size, scale_factors
  if antialias:
    _50 = torch.__contains__(["bilinear", "bicubic"], mode)
    if _50:
      _51 = torch.eq(torch.dim(input), 4)
    else:
      _51 = False
    _49 = torch.__not__(_51)
  else:
    _49 = False
  if _49:
    ops.prim.RaiseException(_10, "builtins.ValueError")
  else:
    pass
  if torch.eq(torch.dim(input), 3):
    _52 = torch.eq(mode, "nearest")
  else:
    _52 = False
  if _52:
    _54 = torch.upsample_nearest1d(input, output_size3, scale_factors2)
    _53 = _54
  else:
    if torch.eq(torch.dim(input), 4):
      _55 = torch.eq(mode, "nearest")
    else:
      _55 = False
    if _55:
      _57 = torch.upsample_nearest2d(input, output_size3, scale_factors2)
      _56 = _57
    else:
      if torch.eq(torch.dim(input), 5):
        _58 = torch.eq(mode, "nearest")
      else:
        _58 = False
      if _58:
        _60 = torch.upsample_nearest3d(input, output_size3, scale_factors2)
        _59 = _60
      else:
        if torch.eq(torch.dim(input), 3):
          _62 = torch.eq(mode, "nearest-exact")
          _61 = _62
        else:
          _61 = False
        if _61:
          _64 = torch._upsample_nearest_exact1d(input, output_size3, scale_factors2)
          _63 = _64
        else:
          if torch.eq(torch.dim(input), 4):
            _66 = torch.eq(mode, "nearest-exact")
            _65 = _66
          else:
            _65 = False
          if _65:
            _68 = torch._upsample_nearest_exact2d(input, output_size3, scale_factors2)
            _67 = _68
          else:
            _69 = torch.eq(torch.dim(input), 5)
            if _69:
              _71 = torch.eq(mode, "nearest-exact")
              _70 = _71
            else:
              _70 = False
            if _70:
              _73 = torch._upsample_nearest_exact3d(input, output_size3, scale_factors2)
              _72 = _73
            else:
              _74 = torch.eq(torch.dim(input), 3)
              if _74:
                _75 = torch.eq(mode, "area")
              else:
                _75 = False
              if _75:
                _77 = torch.__isnot__(output_size3, None)
                if _77:
                  output_size6 = unchecked_cast(List[int], output_size3)
                  output_size5 = output_size6
                else:
                  ops.prim.RaiseException("AssertionError: ")
                  output_size5 = _21
                _78 = torch.adaptive_avg_pool1d(input, output_size5)
                _76 = _78
              else:
                _79 = torch.eq(torch.dim(input), 4)
                if _79:
                  _81 = torch.eq(mode, "area")
                  _80 = _81
                else:
                  _80 = False
                if _80:
                  _83 = torch.__isnot__(output_size3, None)
                  if _83:
                    output_size8 = unchecked_cast(List[int], output_size3)
                    output_size7 = output_size8
                  else:
                    ops.prim.RaiseException("AssertionError: ")
                    output_size7 = _21
                  _84 = _11(input, output_size7, )
                  _82 = _84
                else:
                  _85 = torch.eq(torch.dim(input), 5)
                  if _85:
                    _87 = torch.eq(mode, "area")
                    _86 = _87
                  else:
                    _86 = False
                  if _86:
                    _89 = torch.__isnot__(output_size3, None)
                    if _89:
                      output_size10 = unchecked_cast(List[int], output_size3)
                      output_size9 = output_size10
                    else:
                      ops.prim.RaiseException("AssertionError: ")
                      output_size9 = _21
                    _90 = _12(input, output_size9, )
                    _88 = _90
                  else:
                    _91 = torch.eq(torch.dim(input), 3)
                    if _91:
                      _93 = torch.eq(mode, "linear")
                      _92 = _93
                    else:
                      _92 = False
                    if _92:
                      _95 = torch.__isnot__(align_corners0, None)
                      if _95:
                        align_corners5 = unchecked_cast(bool, align_corners0)
                        align_corners4 = align_corners5
                      else:
                        ops.prim.RaiseException("AssertionError: ")
                        align_corners4 = _29
                      _96 = torch.upsample_linear1d(input, output_size3, align_corners4, scale_factors2)
                      _94 = _96
                    else:
                      _97 = torch.eq(torch.dim(input), 4)
                      if _97:
                        _99 = torch.eq(mode, "bilinear")
                        _98 = _99
                      else:
                        _98 = False
                      if _98:
                        _101 = torch.__isnot__(align_corners0, None)
                        if _101:
                          align_corners7 = unchecked_cast(bool, align_corners0)
                          align_corners6 = align_corners7
                        else:
                          ops.prim.RaiseException("AssertionError: ")
                          align_corners6 = _29
                        if antialias:
                          _103 = torch._upsample_bilinear2d_aa(input, output_size3, align_corners6, scale_factors2)
                          _102 = _103
                        else:
                          _104 = torch.upsample_bilinear2d(input, output_size3, align_corners6, scale_factors2)
                          _102 = _104
                        _100 = _102
                      else:
                        _105 = torch.dim(input)
                        _106 = torch.eq(_105, 5)
                        if _106:
                          _108 = torch.eq(mode, "trilinear")
                          _107 = _108
                        else:
                          _107 = False
                        if _107:
                          _110 = torch.__isnot__(align_corners0, None)
                          if _110:
                            align_corners9 = unchecked_cast(bool, align_corners0)
                            align_corners8 = align_corners9
                          else:
                            ops.prim.RaiseException("AssertionError: ")
                            align_corners8 = _29
                          _111 = torch.upsample_trilinear3d(input, output_size3, align_corners8, scale_factors2)
                          _109 = _111
                        else:
                          _112 = torch.dim(input)
                          _113 = torch.eq(_112, 4)
                          if _113:
                            _115 = torch.eq(mode, "bicubic")
                            _114 = _115
                          else:
                            _114 = False
                          if _114:
                            _117 = torch.__isnot__(align_corners0, None)
                            if _117:
                              align_corners11 = unchecked_cast(bool, align_corners0)
                              align_corners10 = align_corners11
                            else:
                              ops.prim.RaiseException("AssertionError: ")
                              align_corners10 = _29
                            if antialias:
                              _119 = torch._upsample_bicubic2d_aa(input, output_size3, align_corners10, scale_factors2)
                              _118 = _119
                            else:
                              _120 = torch.upsample_bicubic2d(input, output_size3, align_corners10, scale_factors2)
                              _118 = _120
                            _116 = _118
                          else:
                            _121 = torch.dim(input)
                            _122 = torch.eq(_121, 3)
                            if _122:
                              _124 = torch.eq(mode, "bilinear")
                              _123 = _124
                            else:
                              _123 = False
                            if _123:
                              ops.prim.RaiseException(_13, "builtins.NotImplementedError")
                            else:
                              pass
                            _125 = torch.dim(input)
                            _126 = torch.eq(_125, 3)
                            if _126:
                              _128 = torch.eq(mode, "trilinear")
                              _127 = _128
                            else:
                              _127 = False
                            if _127:
                              ops.prim.RaiseException(_14, "builtins.NotImplementedError")
                            else:
                              pass
                            _129 = torch.dim(input)
                            _130 = torch.eq(_129, 4)
                            if _130:
                              _132 = torch.eq(mode, "linear")
                              _131 = _132
                            else:
                              _131 = False
                            if _131:
                              ops.prim.RaiseException(_15, "builtins.NotImplementedError")
                            else:
                              pass
                            _133 = torch.dim(input)
                            _134 = torch.eq(_133, 4)
                            if _134:
                              _136 = torch.eq(mode, "trilinear")
                              _135 = _136
                            else:
                              _135 = False
                            if _135:
                              ops.prim.RaiseException(_16, "builtins.NotImplementedError")
                            else:
                              pass
                            _137 = torch.dim(input)
                            _138 = torch.eq(_137, 5)
                            if _138:
                              _140 = torch.eq(mode, "linear")
                              _139 = _140
                            else:
                              _139 = False
                            if _139:
                              ops.prim.RaiseException(_17, "builtins.NotImplementedError")
                            else:
                              pass
                            _141 = torch.dim(input)
                            _142 = torch.eq(_141, 5)
                            if _142:
                              _144 = torch.eq(mode, "bilinear")
                              _143 = _144
                            else:
                              _143 = False
                            if _143:
                              ops.prim.RaiseException(_18, "builtins.NotImplementedError")
                            else:
                              pass
                            _145 = torch.dim(input)
                            _146 = torch.format(_19, _145, mode)
                            ops.prim.RaiseException(_146, "builtins.NotImplementedError")
                            _116 = _20
                          _109 = _116
                        _100 = _109
                      _94 = _100
                    _88 = _94
                  _82 = _88
                _76 = _82
              _72 = _76
            _67 = _72
          _63 = _67
        _59 = _63
      _56 = _59
    _53 = _56
  return _53
def adaptive_avg_pool2d(input: Tensor,
    output_size: List[int]) -> Tensor:
  _147 = torch.gt(torch.len(torch.size(input)), torch.len(output_size))
  if _147:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _148 = torch.adaptive_avg_pool2d(input, output_size)
  return _148
def adaptive_avg_pool3d(input: Tensor,
    output_size: List[int]) -> Tensor:
  _149 = torch.gt(torch.len(torch.size(input)), torch.len(output_size))
  if _149:
    pass
  else:
    ops.prim.RaiseException("AssertionError: ")
  _150 = torch.adaptive_avg_pool3d(input, output_size)
  return _150
