class MelSpectrogram(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  power : float
  normalized : bool
  f_max : NoneType
  spectrogram : __torch__.torchaudio.transforms._transforms.Spectrogram
  mel_scale : __torch__.torchaudio.transforms._transforms.MelScale
  f_min : Final[float] = 0.
  hop_length : Final[int] = 32
  n_fft : Final[int] = 1024
  sample_rate : Final[int] = 48000
  win_length : Final[int] = 1024
  pad : Final[int] = 0
  n_mels : Final[int] = 128
  def forward(self: __torch__.torchaudio.transforms._transforms.MelSpectrogram,
    waveform: Tensor) -> Tensor:
    spectrogram = self.spectrogram
    specgram = (spectrogram).forward(waveform, )
    mel_scale = self.mel_scale
    return (mel_scale).forward(specgram, )
class Spectrogram(Module):
  __parameters__ = []
  __buffers__ = ["window", ]
  window : Tensor
  training : bool
  _is_full_backward_hook : Optional[bool]
  center : bool
  pad_mode : str
  onesided : bool
  win_length : Final[int] = 1024
  n_fft : Final[int] = 1024
  power : Final[float] = 2.
  normalized : Final[bool] = False
  hop_length : Final[int] = 32
  pad : Final[int] = 0
  def forward(self: __torch__.torchaudio.transforms._transforms.Spectrogram,
    waveform: Tensor) -> Tensor:
    _0 = __torch__.torchaudio.functional.functional.spectrogram
    window = self.window
    center = self.center
    pad_mode = self.pad_mode
    onesided = self.onesided
    _1 = _0(waveform, 0, window, 1024, 32, 1024, 2., False, center, pad_mode, onesided, None, )
    return _1
class MelScale(Module):
  __parameters__ = []
  __buffers__ = ["fb", ]
  fb : Tensor
  training : bool
  _is_full_backward_hook : Optional[bool]
  norm : NoneType
  mel_scale : str
  f_min : Final[float] = 0.
  f_max : Final[float] = 24000.
  sample_rate : Final[int] = 48000
  n_mels : Final[int] = 128
  def forward(self: __torch__.torchaudio.transforms._transforms.MelScale,
    specgram: Tensor) -> Tensor:
    _2 = torch.transpose(specgram, -1, -2)
    fb = self.fb
    mel_specgram = torch.transpose(torch.matmul(_2, fb), -1, -2)
    return mel_specgram
class FrequencyMasking(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  mask_param : Final[int] = 0
  p : Final[float] = 1.
  axis : Final[int] = 1
  iid_masks : Final[bool] = False
  def forward(self: __torch__.torchaudio.transforms._transforms.FrequencyMasking,
    specgram: Tensor,
    mask_value: float=0.) -> Tensor:
    _3 = __torch__.torchaudio.functional.functional.mask_along_axis
    _4 = torch.sub(torch.add(1, torch.dim(specgram)), 3)
    _5 = _3(specgram, 0, mask_value, _4, 1., )
    return _5
